//---------------------------------------------------------------------------

#include <basepch.h>

#pragma hdrstop

#include "DataConverter.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//
static inline void ValidCtrCheck(TDataConverter *)
{
        new TDataConverter(NULL);
}
//---------------------------------------------------------------------------
__fastcall TDataConverter::TDataConverter(TComponent* Owner)
        : TComponent(Owner)
{
  FToolsStream = new TMemoryStream () ;
}
//---------------------------------------------------------------------------
__fastcall TDataConverter::~TDataConverter()
{
   delete FToolsStream ;
}
//---------------------------------------------------------------------------
void __fastcall TDataConverter::BinToStr ( AnsiString& Destination , TMemoryStream* Source )
{
  // Encoding
  char EOLS = 0 ;
  byte Bt     ;
  AnsiString Out ;
  Source -> Position = 0 ;

  TMemoryStream* so = new TMemoryStream () ;
  so -> Size = Source -> Size * 2 ;

  for ( int i = 0 ; i < Source -> Size ; i ++ )
    {
     Source -> Read( &Bt , 1 ) ;
     Out = IntToHex( Bt , 2 ) ;
     so -> Write( Out.c_str() , 2 )  ;
    }
  so -> Write( &EOLS , 1 )  ;

  Destination = (char *)so -> Memory ;
  delete so ;
}
//---------------------------------------------------------------------------
void __fastcall TDataConverter::StrToBin ( TMemoryStream* Destination , AnsiString Source  )
{
  byte Bt     ;
  char Wt[5] ;
  Wt[0]='0' ;
  Wt[1]='x' ;
  Wt[4]= 0  ;

  TMemoryStream* si = new TMemoryStream () ;

  si -> Write ( Source.c_str() , Source.Length() ) ;
  si -> Position = 0 ;
  Destination -> Size = si -> Size / 2 ;

  Destination -> Position = 0 ;
  for ( int i = 0 ; i < (si -> Size - 1)/2 ; i ++ )
    {
     si -> Read ( Wt + 2 , 2 ) ;
     Bt = Sysutils::StrToInt (Wt) ;
     Destination -> Write( &Bt , 1 )  ;
     }
   Destination -> Position = 0 ;

   delete si ;

}
//---------------------------------------------------------------------------
void __fastcall TDataConverter::NotifyBinToStr ( AnsiString& Destination , TMemoryStream* Source )
{
  // Encoding
  char EOLS = 0 ;
  byte Bt     ;
  AnsiString Out ;
  Source -> Position = 0 ;

  TMemoryStream* so = new TMemoryStream () ;
  so -> Size = Source -> Size * 2 ;

  int Percent = Source -> Size / 100 ;
  int Progress = 0 ;

  for ( int i = 0 ; i < Source -> Size ; i ++ )
    {
     Source -> Read( &Bt , 1 ) ;
     Out = IntToHex( Bt , 2 ) ;
     so -> Write( Out.c_str() , 2 )  ;
     if ( i > ( Progress + 1 )*Percent )
      if ( OnProgress )
       {
        OnProgress( this , Progress ) ;
        Progress ++ ;
       }
    }
  so -> Write( &EOLS , 1 )  ;

  Destination = (char *)so -> Memory ;
  delete so ;
}
//---------------------------------------------------------------------------
void __fastcall TDataConverter::NotifyStrToBin ( TMemoryStream* Destination , AnsiString Source  )
{
  byte Bt     ;
  char Wt[5] ;
  Wt[0]='0' ;
  Wt[1]='x' ;
  Wt[4]= 0  ;

  TMemoryStream* si = new TMemoryStream () ;


  int Percent = Source.Length() / 200 ;
  int Progress = 0 ;

  si -> Write ( Source.c_str() , Source.Length() ) ;
  si -> Position = 0 ;
  Destination -> Size = si -> Size / 2 ;

  Destination -> Position = 0 ;
  for ( int i = 0 ; i < (si -> Size - 1)/2 ; i ++ )
    {
     si -> Read ( Wt + 2 , 2 ) ;
     Bt = Sysutils::StrToInt (Wt) ;
     Destination -> Write( &Bt , 1 )  ;
     if ( i > ( Progress + 1 )*Percent )
      if ( OnProgress )
       {
        OnProgress( this , Progress ) ;
        Progress ++ ;
       }
    }
   Destination -> Position = 0 ;

   delete si ;

}
//---------------------------------------------------------------------------
void __fastcall TDataConverter::SetNotification(bool value)
{
  if(FNotification != value)
   {
    FNotification = value;
   }
}
//----------------------------------------------------------------------------
bool __fastcall TDataConverter::GetNotification()
{
   return FNotification;
}
//----------------------------------------------------------------------------
void __fastcall TDataConverter::Encode ( AnsiString& Destination , TMemoryStream* Source )
{
 if ( Notification ) NotifyBinToStr( Destination , Source ) ;
 else BinToStr(Destination , Source) ;
}
//----------------------------------------------------------------------------
void __fastcall TDataConverter::Decode ( TMemoryStream* Destination , AnsiString Source )
{
 if ( Notification ) NotifyStrToBin( Destination , Source ) ;
 else StrToBin(Destination , Source) ;
}
//-----------------------------------------------------------------------------
void __fastcall TDataConverter::Encode ( AnsiString& Destination )
{
  if ( Notification ) NotifyBinToStr( Destination , ToolsStream ) ;
  else BinToStr(Destination , ToolsStream) ;
}
//-----------------------------------------------------------------------------
void __fastcall TDataConverter::Decode ( AnsiString Source )
{
  if ( Notification ) NotifyStrToBin( ToolsStream , Source ) ;
  else StrToBin(ToolsStream , Source) ;
}
//-----------------------------------------------------------------------------
AnsiString __fastcall TDataConverter::EncodeEx ()
{
  TMemoryStream* Dest = new TMemoryStream () ;
  ToolsStream -> Position = 0 ;
  ObjectBinaryToText( ToolsStream , Dest );
  char EOL = 0 ;
  Dest -> Write ( &EOL , 1 ) ;
  Dest -> Position = 0 ;
  AnsiString Tmp = (char*) Dest -> Memory ;
  delete Dest ;
  return Tmp ;

}
//-----------------------------------------------------------------------------
void __fastcall TDataConverter::DecodeEx ( AnsiString Source)
{
  ToolsStream -> Clear () ;
  TStringStream* Src = new TStringStream (Source) ;
  Src -> Position = 0 ;
  ObjectTextToBinary( Src , ToolsStream );
  delete Src ;
}


