//---------------------------------------------------------------------------

#ifndef DataConverterH
#define DataConverterH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>

typedef void __fastcall (__closure *TDataConverterNotifyEvent)(System::TObject* Sender , int Percent );

//---------------------------------------------------------------------------
class PACKAGE TDataConverter : public TComponent
{
private:
        bool FNotification;
        TMemoryStream* FToolsStream ;

        void __fastcall SetNotification(bool value);
        bool __fastcall GetNotification();

        TDataConverterNotifyEvent FOnProgress;
        
        void __fastcall BinToStr ( AnsiString& Destination , TMemoryStream* Source ) ;
        void __fastcall StrToBin ( TMemoryStream* Destination , AnsiString Source  ) ;
        void __fastcall NotifyBinToStr ( AnsiString& Destination , TMemoryStream* Source ) ;
        void __fastcall NotifyStrToBin ( TMemoryStream* Destination , AnsiString Source  ) ;
protected:
public:

   __fastcall TDataConverter(TComponent* Owner);
        void __fastcall Encode ( AnsiString& Destination , TMemoryStream* Source  ) ;
        void __fastcall Decode ( TMemoryStream* Destination , AnsiString Source ) ;

        void __fastcall Encode ( AnsiString& Destination ) ;
        void __fastcall Decode ( AnsiString Source ) ;

        AnsiString __fastcall EncodeEx () ;
        void __fastcall DecodeEx ( AnsiString Source) ;


        __fastcall ~TDataConverter();
        __property TMemoryStream* ToolsStream  = { read=FToolsStream, write=FToolsStream };
__published:
   __property bool Notification  = { read=GetNotification, write=SetNotification };
   __property TDataConverterNotifyEvent OnProgress = {read=FOnProgress , write=FOnProgress};
};
//---------------------------------------------------------------------------
#endif
