//---------------------------------------------------------------------------


#pragma hdrstop

#include "FormNotifier.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)  

__fastcall TFormNotifier::TFormNotifier( _di_IOTAEditor Editor, _di_IOTAFormEditor FormEditor )
    : index(-1) , Editor(Editor) , FormEditor(FormEditor)
{
  index = Editor -> AddNotifier ((_di_IOTAFormNotifier)this) ;
}

__fastcall TFormNotifier::~TFormNotifier()
{
   if ( index >= 1)
    Editor -> RemoveNotifier(index) ;
}
//----------------------------------------------------



//    IOTAFormNotifier
void __fastcall TFormNotifier::FormActivated()
  {
  }
void __fastcall TFormNotifier::FormSaving()
  {
  }
void __fastcall TFormNotifier::ComponentRenamed(void * ComponentHandle, const AnsiString OldName, const AnsiString NewName)
  {
    //       TXMLPropsStorage
    if ( OldName.IsEmpty() )
     {
      //    , 
      return ;
     }

    TComponent* Component = (TComponent*)ComponentHandle ;
    TComponent* RootComponent = NULL ;
    if ( Component -> Owner )
         RootComponent = Component -> Owner ;
    else
         RootComponent = Component ;

    //    TXMLPropsStorage
    for ( int ComponentIndex = 0 ; ComponentIndex < RootComponent->ComponentCount ; ComponentIndex++ )
      {
        if ( AnsiString(RootComponent->Components[ComponentIndex]->ClassName()) == "TXMLPropsStorage" )
         {
           TXMLPropsStorage* XMLPropsStorage = (TXMLPropsStorage*)RootComponent->Components[ComponentIndex] ;

           if ( XMLPropsStorage == ComponentHandle && NewName.IsEmpty() ) continue ;
           //        TXMLPropsStorage   
           for ( int Index = 0 ; Index < XMLPropsStorage->StoredProps->Count ; Index ++ )
            {
              AnsiString StoredComponent =  XMLPropsStorage->StoredProps -> Strings[Index].Delete(XMLPropsStorage->StoredProps -> Strings[Index].Pos("."),
                                                                                                  XMLPropsStorage->StoredProps -> Strings[Index].Length()).Delete(1,4) ;

              AnsiString Flags = XMLPropsStorage->StoredProps -> Strings[Index].SubString(1,4) ;
              AnsiString Property = XMLPropsStorage->StoredProps -> Strings[Index].SubString ( XMLPropsStorage->StoredProps -> Strings[Index].Pos(".") ,
                                                                                                  XMLPropsStorage->StoredProps -> Strings[Index].Length() ) ;

              if ( StoredComponent == OldName )
              {
                if ( NewName.IsEmpty() )
                  {
                   //     -    
                   //  ,    
                   XMLPropsStorage->StoredProps -> Delete(Index) ;
                   Index -- ;
                  }
                else
                  {
                   //   -    
                   //  ,    
                   XMLPropsStorage->StoredProps -> Strings[Index] = Flags + NewName + Property ;
                  }
               }
            }
         }
      }
  }




  //   IInterface
HRESULT __stdcall TFormNotifier::QueryInterface(const GUID& iid, void** obj)
{
  QUERY_INTERFACE (IOTAFormNotifier, iid , obj ) ;
  return inherited::QueryInterface(iid,obj) ;
}
ULONG   __stdcall TFormNotifier::AddRef()
{
  return inherited::AddRef() ;
}
ULONG   __stdcall TFormNotifier::Release()
{
  return inherited::Release() ;
}

//   NotifierObject
void __fastcall TFormNotifier::AfterSave() {} ;
void __fastcall TFormNotifier::BeforeSave(){} ;
void __fastcall TFormNotifier::Destroyed()
{
  if (index >= 0)
   {
    Editor->RemoveNotifier(index);
    index = -1;
   }
  //Editor = NULL ;
}
void __fastcall TFormNotifier::Modified()  {} ;



