//---------------------------------------------------------------------------

#ifndef FormNotifierH
#define FormNotifierH

#include <vcl.h>
#include <DesignEditors.hpp>
#include <DesignIntf.hpp>

#include "ToolsAPIEx.h"
#include "XMLPropsStorage.h"

namespace Klentoolslibed
{

//  
class PACKAGE TFormNotifier :  public TNotifierObject,
                               public IOTAFormNotifier
{
  public:

  typedef TNotifierObject inherited ;

  __fastcall  TFormNotifier(  _di_IOTAEditor Editor , _di_IOTAFormEditor FormEditor );
  __fastcall ~TFormNotifier();

  //    IOTAFormNotifier
  void __fastcall FormActivated()  ;
  void __fastcall FormSaving()   ;
  void __fastcall ComponentRenamed(void * ComponentHandle, const AnsiString OldName, const AnsiString NewName) ;

  //   NotifierObject
  void __fastcall AfterSave();
  void __fastcall BeforeSave();
  void __fastcall Destroyed();
  void __fastcall Modified();


 protected:
  //   IInterface
  virtual HRESULT __stdcall QueryInterface(const GUID&, void**);
  virtual ULONG   __stdcall AddRef();
  virtual ULONG   __stdcall Release();

  int index ;
  _di_IOTAEditor Editor ;
  _di_IOTAFormEditor FormEditor ;

};

}

using namespace Klentoolslibed ;

//---------------------------------------------------------------------------
#endif
