//---------------------------------------------------------------------------


#pragma hdrstop

#include "IDENotifier.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

__fastcall TIDENotifier::TIDENotifier(  const _di_IOTAServices IDEServices )
      :  index(-1) , IDEServices(IDEServices)
{
    NotifierRecords = new TList () ;
    index = IDEServices  -> AddNotifier (this) ;
}
//----------------------------------------------------------------------------
__fastcall TIDENotifier::~TIDENotifier()
{
  try {

  if ( index >= 0 )
    IDEServices -> RemoveNotifier(index) ;

  delete NotifierRecords ;

  } catch (...)
  {
   MessageBox (NULL,"   TIDENotifier::~TIDENotifier" ,  "" , MB_OK )  ;
  }
}
//----------------------------------------------------------------------------
//    IOTAIDENotifier
void __fastcall TIDENotifier::FileNotification(TOTAFileNotification NotifyCode, const AnsiString FileName, bool &Cancel)
{
  try
   {
  //      
  if ( NotifyCode == ofnFileOpened || NotifyCode == ofnFileClosing )
   {
     //     

     //     (IDE)
     _di_IOTAModuleServices ModuleServices ;
     BorlandIDEServices -> Supports ( ModuleServices ) ;
     //     
     _di_IOTAModule Module = ModuleServices -> FindModule(FileName) ;
     if ( Module != NULL )
       {
        //       IOTAFormEditor
        for (int i = 0; i < Module->ModuleFileCount; ++i)
          {
           //     
           _di_IOTAEditor Editor = Module->ModuleFileEditors[i];
           _di_IOTAFormEditor FormEditor ;
           //      IOTAFormEditor
           if (Editor->Supports(FormEditor))
            {
             //   
             if ( NotifyCode == ofnFileOpened )
              {
                //  
                TFormNotifier* FormNotifier = new TFormNotifier ( Editor , FormEditor ) ;
                TNotifierRecord* NotifierRecord = new TNotifierRecord ;
                NotifierRecord -> FormNotifier = FormNotifier ;
                NotifierRecord -> Editor = Editor ;
                NotifierRecords -> Add (NotifierRecord) ;
              }
             else
              {
                //  
                //    
                for ( int RecordIndex = 0 ; RecordIndex < NotifierRecords -> Count ; RecordIndex ++ )
                 {
                   TNotifierRecord* NotifierRecord = (TNotifierRecord* ) NotifierRecords -> Items[RecordIndex] ;
                   if ( NotifierRecord -> Editor == Editor)
                    {
                      //  
                      NotifierRecord -> FormNotifier -> Destroyed() ;
                      NotifierRecord -> FormNotifier = 0 ;
                    }
                   delete NotifierRecord ;
                   NotifierRecords -> Delete (RecordIndex) ;
                 }
              }
            }
          }
       }
    }
  } catch (...)
  {
    MessageBox (NULL,"   TIDENotifier::FileNotification" ,  "" , MB_OK )  ;
  }

}
//--------------------------------------------------------------------------------------------
void __fastcall TIDENotifier::BeforeCompile(const _di_IOTAProject Project, bool &Cancel)
{
}
//--------------------------------------------------------------------------------------------
void __fastcall TIDENotifier::AfterCompile(bool Succeeded)
{
}
//--------------------------------------------------------------------------------------------
  //   IInterface
HRESULT __stdcall TIDENotifier::QueryInterface(const GUID& iid, void** obj)
{
  QUERY_INTERFACE ( IOTAIDENotifier, iid , obj ) ;
  return inherited::QueryInterface(iid,obj) ;
}
//--------------------------------------------------------------------------------------------
ULONG   __stdcall TIDENotifier::AddRef()
{
  return inherited::AddRef() ;
}
//--------------------------------------------------------------------------------------------
ULONG   __stdcall TIDENotifier::Release()
{
  return inherited::Release() ;
}
//--------------------------------------------------------------------------------------------
//   NotifierObject
void __fastcall TIDENotifier::AfterSave() {} ;
void __fastcall TIDENotifier::BeforeSave(){} ;
void __fastcall TIDENotifier::Destroyed()
{
  try
    {
     //     
     for ( int RecordIndex = 0 ; RecordIndex < NotifierRecords -> Count ; RecordIndex ++ )
       {
        TNotifierRecord* NotifierRecord = (TNotifierRecord* ) NotifierRecords -> Items[RecordIndex] ;
        //  
        NotifierRecord -> FormNotifier -> Destroyed() ;
        NotifierRecord -> FormNotifier = 0 ;
       }
     if (index >= 0)
       {
        IDEServices->RemoveNotifier(index);
        index = -1;
       }
    }
  catch (...)
    {
      MessageBox (NULL,"  TIDENotifier::Destroyed()" ,  "" , MB_OK )  ;
    }
  //IDEServices = NULL ;
}
//--------------------------------------------------------------------------------------------
void __fastcall TIDENotifier::Modified()  {} ;



