//---------------------------------------------------------------------------

#ifndef IDENotifierH
#define IDENotifierH

#include <vcl.h>
#include <DesignEditors.hpp>
#include <DesignIntf.hpp>

#include "ToolsAPIEx.h"
#include "FormNotifier.h"

namespace Klentoolslibed
{

//  
class PACKAGE TIDENotifier :  public TNotifierObject,
                              public IOTAIDENotifier
{
  public:

  typedef TNotifierObject inherited ;

  __fastcall  TIDENotifier(  _di_IOTAServices IDEServices );
  __fastcall ~TIDENotifier() ;

  //    IOTAIDENotifier
  void __fastcall FileNotification(TOTAFileNotification NotifyCode, const AnsiString FileName, bool &Cancel) ;
  void __fastcall BeforeCompile(const _di_IOTAProject Project, bool &Cancel);
  void __fastcall AfterCompile(bool Succeeded) ;

  //   NotifierObject
  void __fastcall AfterSave();
  void __fastcall BeforeSave();
  void __fastcall Destroyed();
  void __fastcall Modified();


 protected:
  //   IInterface
  virtual HRESULT __stdcall QueryInterface(const GUID&, void**);
  virtual ULONG   __stdcall AddRef();
  virtual ULONG   __stdcall Release();

  int index ;
  _di_IOTAServices IDEServices ;

  TList* NotifierRecords ;
  typedef struct
         {
           TFormNotifier*   FormNotifier ;
           _di_IOTAEditor   Editor ;
         }  TNotifierRecord ;

};

}
using namespace Klentoolslibed ;

//---------------------------------------------------------------------------
#endif
