//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include "KlenButton.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TKlenButton *)
{
        new TKlenButton(NULL);
}
//---------------------------------------------------------------------------
__fastcall TKlenButton::TKlenButton(TComponent* Owner)
        : TPanel(Owner)
{
   FActiveFontColor = clBlue ;
   FPassiveFontColor = clNone ;
   BevelOuter = bvNone ;
   TPanel::OnMouseMove = OnMouseMoveEx ;
   TPanel::OnClick = OnClickEx ;
   TPanel::OnMouseUp = OnMouseUpEx ;
   TPanel::OnMouseDown = OnMouseDownEx ;
   FStateIndex = 0 ;
}
//---------------------------------------------------------------------------
__fastcall TKlenButton::~TKlenButton()
{
}
//---------------------------------------------------------------------------
void __fastcall TKlenButton::OnMouseMoveEx (System::TObject* Sender, Classes::TShiftState Shift, int X, int Y)
{
  if ( Shift.Contains(ssLeft))
     BevelOuter = bvLowered ;
  else
     BevelOuter = bvRaised ;

  Font->Color=FActiveFontColor ;
  FStateIndex  = 1 ;

  TRACKMOUSEEVENT TrackEvent ;
  TrackEvent.cbSize = sizeof(TRACKMOUSEEVENT);
  TrackEvent.dwFlags = TME_LEAVE ;
  TrackEvent.hwndTrack = Handle ;
  TrackEvent.dwHoverTime = NULL ;
  TrackMouseEvent (&TrackEvent ) ;

  Repaint () ;

  if ( FOnMouseMove ) FOnMouseMove (Sender, Shift, X, Y) ;
}
//---------------------------------------------------------------------------
void __fastcall TKlenButton::OnClickEx (System::TObject* Sender)
{
  if ( FOnClick ) FOnClick (Sender) ;
}
//---------------------------------------------------------------------------
void __fastcall TKlenButton::OnMouseUpEx (System::TObject* Sender, TMouseButton Button, Classes::TShiftState Shift, int X, int Y)
{

  if ( FOnMouseUp ) FOnMouseUp (Sender, Button, Shift, X, Y) ;
}
//---------------------------------------------------------------------------
void __fastcall TKlenButton::OnMouseDownEx (System::TObject* Sender, TMouseButton Button, Classes::TShiftState Shift, int X, int Y)
{
  BevelOuter = bvLowered ;
  if ( FOnMouseDown ) FOnMouseDown (Sender, Button, Shift, X, Y) ;
}
//---------------------------------------------------------------------------
void __fastcall TKlenButton::SetActiveFontColor(TColor value)
{
  FActiveFontColor = value;
}
//---------------------------------------------------------------------------
void __fastcall TKlenButton::SetPassiveFontColor(TColor value)
{
  FPassiveFontColor = value;
}
//---------------------------------------------------------------------------
void __fastcall TKlenButton::Paint()
{
  TPanel::Paint() ;
  if (FImageList)
   {
     int ImageIndex = FStateIndex ? FActiveImageIndex : FPassiveImageIndex ;
     Graphics::TBitmap* Bitmap = new Graphics::TBitmap () ;
     FImageList -> GetBitmap ( ImageIndex , Bitmap ) ;
     Bitmap->Height = Height - 2 ;
     Canvas->Draw ( 1 , 1 , Bitmap )  ;
     delete Bitmap ;
   }
}
//---------------------------------------------------------------------------
void __fastcall TKlenButton::SetActiveImageIndex ( int Val )
{
 FActiveImageIndex = Val ;
 Paint();
}
//---------------------------------------------------------------------------
void __fastcall TKlenButton::SetPassiveImageIndex ( int Val )
{
 FPassiveImageIndex = Val ;
 Paint() ;
}
//---------------------------------------------------------------------------
void __fastcall TKlenButton::DoMouseLeave(TMessage& Message)
{
  BevelOuter = bvNone ;
  Font->Color = FPassiveFontColor ;
  FStateIndex  = 0 ;
  Repaint () ;
}
//---------------------------------------------------------------------------

