//---------------------------------------------------------------------------

#ifndef KlenButtonH
#define KlenButtonH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class PACKAGE TKlenButton : public TPanel
{
private:
       
        TMouseMoveEvent FOnMouseMove ;
        TNotifyEvent FOnClick ;
        TMouseEvent FOnMouseUp ;
        TMouseEvent FOnMouseDown ;

        TColor FActiveFontColor ;
        TColor FPassiveFontColor ;

        int FStateIndex ;
        TImageList* FImageList ;
        int FActiveImageIndex  ;
        int FPassiveImageIndex ;

        void __fastcall SetActiveFontColor(TColor value);
        void __fastcall SetPassiveFontColor(TColor value);
        void __fastcall SetActiveImageIndex ( int Val ) ;
        void __fastcall SetPassiveImageIndex ( int Val ) ;

protected:

   void __fastcall OnMouseMoveEx (System::TObject* Sender, Classes::TShiftState Shift, int X, int Y) ;
   void __fastcall OnClickEx (System::TObject* Sender) ;
   void __fastcall OnMouseUpEx (System::TObject* Sender, TMouseButton Button, Classes::TShiftState Shift, int X, int Y) ;
   void __fastcall OnMouseDownEx (System::TObject* Sender, TMouseButton Button, Classes::TShiftState Shift, int X, int Y) ;



   virtual    void   __fastcall Paint();
        BEGIN_MESSAGE_MAP
                VCL_MESSAGE_HANDLER(WM_MOUSELEAVE, TMessage, DoMouseLeave)
        END_MESSAGE_MAP(TPanel)



public:
        __fastcall TKlenButton(TComponent* Owner);
        __fastcall ~TKlenButton() ;
        void __fastcall DoMouseLeave(TMessage& Message);
        
__published:
    __property TMouseMoveEvent OnMouseMove = {read=FOnMouseMove, write=FOnMouseMove};
    __property TNotifyEvent OnClick = {read=FOnClick, write=FOnClick};
    __property TMouseEvent OnMouseUp = {read=FOnMouseUp, write=FOnMouseUp};
    __property TMouseEvent OnMouseDown = {read=FOnMouseDown, write=FOnMouseDown};

    __property TColor ActiveFontColor  = { read=FActiveFontColor, write=SetActiveFontColor , default=clBlue};
    __property TColor PassiveFontColor  = { read=FPassiveFontColor, write=SetPassiveFontColor , default=clNone};

    __property TImageList* ImageList  = { read=FImageList , write=FImageList };
    __property int ActiveImageIndex  = { read=FActiveImageIndex , write=SetActiveImageIndex };
    __property int PassiveImageIndex  = { read=FPassiveImageIndex ,  write=SetPassiveImageIndex};

 };
//---------------------------------------------------------------------------
#endif
