//---------------------------------------------------------------------------

#ifndef NotifierWizardH
#define NotifierWizardH

#include <vcl.h>
#include <DesignEditors.hpp>
#include <DesignIntf.hpp>
#include "ToolsAPIEx.h"

#include "IDENotifier.h"
#include "FormNotifier.h"
#include "KlenAbout.h"
#include "StoredPropEditor.h"


namespace Klentoolslibed
{

//  

class PACKAGE TWizard :  public TNotifierObject,
                         public IOTAMenuWizard

{
  public:

  typedef TNotifierObject inherited ;

  __fastcall TWizard();
  __fastcall ~TWizard();

 //   

 //   IOTAMenuWizard
 AnsiString __fastcall GetIDString () ;
 AnsiString __fastcall GetName () ;
 TWizardState __fastcall GetState () ;
 AnsiString __fastcall GetMenuText () ;
 void __fastcall Execute () ;


  //   NotifierObject
  void __fastcall AfterSave();
  void __fastcall BeforeSave();
  void __fastcall Destroyed();  // implement this
  void __fastcall Modified();


 protected:
  //   IInterface
  virtual HRESULT __stdcall QueryInterface(const GUID&, void**);
  virtual ULONG   __stdcall AddRef();
  virtual ULONG   __stdcall Release();

  TFormNotifier*  FormNotifier ;
  TIDENotifier*   IDENotifier  ;

};

void __fastcall PACKAGE Register ()
  {
    try
       {
        RegisterPackageWizard ( new TWizard ) ;
        RegisterComponentEditor ( __classid (TXMLPropsStorage) , __classid(TXMLPropsStorageEitor) ) ;
       }
    catch (...) {} ;
  }

}

using namespace Klentoolslibed ;

//---------------------------------------------------------------------------
#endif
