//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop



#include "XMLPropsStorage.h"
#include "StoredPropEditor.h"
#include "KlenAbout.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

__fastcall TXMLPropsStorageEitor::TXMLPropsStorageEitor (Classes::TComponent* AComponent, Designintf::_di_IDesigner ADesigner)
           : TComponentEditor ( AComponent , ADesigner )
{
}
//---------------------------------------------------------------------------
void __fastcall TXMLPropsStorageEitor::Edit ()
{
   //    
   TStoredPropDlg* Dlg = new TStoredPropDlg (Application , dynamic_cast<TXMLPropsStorage *> ( Component ));
   //  
   Dlg -> ShowModal() ;
   //  
   delete Dlg ;
   Designer->Modified();
}
//---------------------------------------------------------------------------
void __fastcall TXMLPropsStorageEitor::ExecuteVerb(int Index)
{
  //         
  if(Index == 0)
    {
     AboutForm = new TAboutForm (NULL);
     AboutForm -> ShowModal() ;
     delete AboutForm ;
    }
  Designer->Modified();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TXMLPropsStorageEitor::GetVerb(int Index)
{
  return "About KlenToolsLib v0.3.0" ;
}
//---------------------------------------------------------------------------
int __fastcall TXMLPropsStorageEitor::GetVerbCount(void)
{
  return 1 ;
}
//---------------------------------------------------------------------------
__fastcall TStoredPropDlg::TStoredPropDlg(TComponent* Owner , TXMLPropsStorage* AComponent )
        : TForm(Owner)
{
  FTarget = AComponent -> Owner ;
  FXMLPropsStorage = AComponent ;
}
//---------------------------------------------------------------------------
void __fastcall TStoredPropDlg::FormShow(TObject *Sender)
{
 //    
 TreeView -> Items -> BeginUpdate() ;

 //       
 TTreeNode* Node = TreeView -> Items -> AddObject (NULL , FTarget -> Name , FTarget ) ;
 Node -> Data = FTarget  ;

 //    
 if ( dynamic_cast<TForm *> ( FTarget ))
  {
    Node -> ImageIndex = 1 ;
    Node -> SelectedIndex = 1 ;
  }
 if ( dynamic_cast<TDataModule *> ( FTarget ))
  {
    Node -> ImageIndex = 2 ;
    Node -> SelectedIndex = 2 ;
  }
 if ( dynamic_cast<TFrame *> ( FTarget ))
  {
    Node -> ImageIndex = 3 ;
    Node -> SelectedIndex = 3 ;
  }

 //       
 bool NullNamePresent = false ;
 for ( int comp = -1 ; comp < FTarget -> ComponentCount ; comp ++)
  {
   TComponent* Component ;
   //   
   if ( comp ==-1  )
    {
      Component = Target ;
    }
   else
    {
      Component = FTarget -> Components[comp] ;
      if ( AnsiString(Component -> Name).IsEmpty() && !NullNamePresent )
       {
        AnsiString ComponentType = Component -> ClassName () ;
        AnsiString ParentInfo ;
        if ( dynamic_cast<TControl *> ( Component ) )
         {
          ParentInfo = "    :    " + AnsiString(((TControl *)Component) -> Parent -> ClassName ()) + "\r\n\
    :    " + ((TControl *)Component) -> Parent-> Name ;

         }
        ShowMessage (
"   ,      \r\r\
()     . \r\n\
     TXMLPropsStorage \r\n\
  .\r\n\
    :  " + Component -> ClassName () + "\r\n" + ParentInfo
                     ) ;
        NullNamePresent = true ;
        continue ;
       }
      Node = TreeView -> Items -> AddObject (NULL , Component -> Name , Component ) ;
      Node -> Data = Component  ;
      Node -> ImageIndex = 12 ;
      Node -> SelectedIndex = 12 ;
    }
   //      
   int PropCount ;
   PPropInfo* PropInfoList ;
   CreateComponentPropInfo ( Component , &PropCount , &PropInfoList ) ;

   //       
   for ( int Prop = 1 ; Prop < PropCount ; Prop ++)
    {
     //  
     TPropInfo* Info = PropInfoList[Prop]  ;
     //         
     TTreeNode* PropNode = TreeView -> Items -> AddChild ( Node , AnsiString(Info -> Name) /*+ " [" + AnsiString((*(Info->PropType))->Name)+ "]"*/  ) ;
     //   
     int Kind = PropType(  Component , AnsiString(Info -> Name)) ;
     PropNode -> ImageIndex = 5 + Kind ;
     PropNode -> SelectedIndex = 5 + Kind ;
     PropNode -> StateIndex = 1 ;
    }
   //         TStringGrid
   if ( dynamic_cast <TStringGrid*>(Component) )
    {
      TTreeNode* PropNode = TreeView -> Items -> AddChild ( Node , "Cells" ) ;
      PropNode -> ImageIndex = 23 ;
      PropNode -> SelectedIndex = 23 ;
      PropNode -> StateIndex = 1 ;
    }


   Node -> AlphaSort (false) ;
   DeleteComponentPropInfo (PropInfoList) ;
  }



 //    
 StoredPropsListBox -> Clear()  ;
 StoredPropsListBox -> Items -> AddStrings ( XMLPropsStorage -> StoredProps ) ;

 //     
 for ( int NodeIndex = 1 ; NodeIndex < TreeView -> Items -> Count ; NodeIndex ++ )
  {
    //      
    TTreeNode* Node = TreeView -> Items -> Item[NodeIndex] ;
    if ( Node -> Parent )
      {
        //        
        //   .
        AnsiString Props = Node -> Parent -> Text + "." + Node -> Text ;

        //       
        int Index=-1 ;
        for ( int PropIndex = 0 ; PropIndex < StoredPropsListBox->Count ; PropIndex ++ )
         {
           if ( StoredPropsListBox -> Items->Strings[PropIndex].Pos(Props))
             {
              Index = PropIndex ;
              break ;
             }
         }
        if (  Index != -1 )
          {
           //    
           AnsiString Flags =  StoredPropsListBox -> Items->Strings[Index].SubString(1,StoredPropsListBox -> Items->Strings[Index].Pos("  ")) ;
           if (  Flags.Pos("R") && !Flags.Pos("W"))  Node -> StateIndex = 3 ;
           if (  Flags.Pos("R") &&  Flags.Pos("W"))  Node -> StateIndex = 4 ;
           if ( !Flags.Pos("R") &&  Flags.Pos("W"))  Node -> StateIndex = 2 ;
          }
        else
          {
            //   
            Node -> StateIndex = 1 ;
          }
      }
  }

 TreeView -> AlphaSort () ;
 TreeView -> Items -> EndUpdate() ;

 DirectBox -> ItemIndex = XMLPropsStorage -> Direct ;
 
 ActionList1 -> ExecuteAction( ActionList1 -> Actions[0] ) ;

}
//---------------------------------------------------------------------------
void __fastcall TStoredPropDlg::FormHide(TObject *Sender)
{
//       
   //   
   XMLPropsStorage -> Direct =  DirectBox -> ItemIndex;

   //   TXMLPropStorage
   XMLPropsStorage -> StoredProps->Clear();
   //     
   for ( int Index = 0 ; Index < StoredPropsListBox -> Count ; Index ++ )
       XMLPropsStorage -> StoredProps -> Add (  StoredPropsListBox -> Items->Strings[Index] ) ;
}

//---------------------------------------------------------------------------
void __fastcall TStoredPropDlg::CreateComponentPropInfo ( TComponent* Obj , int* PropCount , PPropInfo** PropInfoList )
{
  TTypeData* TypeData = GetTypeData ( (TTypeInfo*)Obj -> ClassInfo()) ;
  *PropCount = TypeData -> PropCount ;
  *PropInfoList = (PPropInfo*)new Pointer [*PropCount * sizeof(Pointer)] ;
  GetPropInfos (  (TTypeInfo*)Obj -> ClassInfo() , *PropInfoList ) ;
}
//----------------------------------------------------------------------------
void __fastcall TStoredPropDlg::DeleteComponentPropInfo ( PPropInfo* PropInfoList)
{
  delete [] *PropInfoList ;
}
//---------------------------------------------------------------------------

void __fastcall TStoredPropDlg::ActionList1Execute(TBasicAction *Action,
      bool &Handled)
{
   if ( StoredPropsListBox -> ItemIndex == -1 )
    {
      RemovePropSpeedButton -> Enabled = false ;
      UpPropButton -> Enabled = false ;
      DownPropButton -> Enabled = false ;
    }
   else
    {
      RemovePropSpeedButton -> Enabled = true ;
      if ( StoredPropsListBox -> ItemIndex != 0 )
         UpPropButton -> Enabled = true ;
      else
         UpPropButton -> Enabled = false ;
      if ( StoredPropsListBox -> ItemIndex != StoredPropsListBox -> Items -> Count - 1 )
         DownPropButton -> Enabled = true ;
      else
         DownPropButton -> Enabled = false ;
    }

}
//---------------------------------------------------------------------------
void __fastcall TStoredPropDlg::TreeViewClick(TObject *Sender)
{
  TTreeNode* Node = TreeView -> Selected ;
  //       
  if ( !Node ) return ;
  if ( !Node -> Parent  ) return ;

  //    
  if ( FX > 38  && FX < 55 )
    {
      switch (Node->StateIndex)
       {
         case 1 :
           {
            Node->StateIndex = 3 ;
            UpdateListBox () ;
            break ;
           }
         case 2 :
           {
            Node->StateIndex = 4 ;
            UpdateListBox () ;
            break ;
           }
          case 3 :
           {
            Node->StateIndex = 1 ;
            UpdateListBox () ;
            break ;
           }
          case 4 :
           {
            Node->StateIndex = 2 ;
            UpdateListBox () ;
            break ;
           }
       }
    }
  if ( FX > 54 && FX < 71 )
    {
            switch (Node->StateIndex)
       {
         case 1 :
           {
            Node->StateIndex = 2 ;
            UpdateListBox () ;
            break ;
           }
         case 2 :
           {
            Node->StateIndex = 1 ;
            UpdateListBox () ;
            break ;
           }
          case 3 :
           {
            Node->StateIndex = 4 ;
            UpdateListBox () ;
            break ;
           }
          case 4 :
           {
            Node->StateIndex = 3 ;
            UpdateListBox () ;
            break ;
           }
       }
    }
  ActionList1 -> ExecuteAction( ActionList1 -> Actions[0] ) ;
}
//---------------------------------------------------------------------------
void __fastcall TStoredPropDlg::StoredPropsListBoxClick(TObject *Sender)
{
  ActionList1 -> ExecuteAction( ActionList1 -> Actions[0] ) ;
}
//---------------------------------------------------------------------------
void __fastcall TStoredPropDlg::RemovePropSpeedButtonClick(TObject *Sender)
{
  int Index = StoredPropsListBox -> ItemIndex ;

  for ( int NodeAbsoluteIndex = 0 ; NodeAbsoluteIndex < TreeView -> Items -> Count ; NodeAbsoluteIndex ++ )
   {
     TTreeNode* Node = TreeView -> Items -> Item[NodeAbsoluteIndex] ;
     if ( Node -> Parent )
      {
        AnsiString Prop = Node -> Parent -> Text ;
        Prop = Prop + "." + Node -> Text ;
        if ( StoredPropsListBox -> Items -> Strings[Index].Pos(Prop))
          Node -> StateIndex = 1 ;
      }
   }

  StoredPropsListBox -> Items -> Delete(Index) ;

  ActionList1 -> ExecuteAction( ActionList1 -> Actions[0] ) ;
}
//---------------------------------------------------------------------------
void __fastcall TStoredPropDlg::UpPropButtonClick(TObject *Sender)
{
  int Index = StoredPropsListBox -> ItemIndex ;
  StoredPropsListBox -> Items ->  Exchange ( Index  , Index - 1 ) ;
  ActionList1 -> ExecuteAction( ActionList1 -> Actions[0] ) ;
}
//---------------------------------------------------------------------------
void __fastcall TStoredPropDlg::DownPropButtonClick(TObject *Sender)
{
  int Index = StoredPropsListBox -> ItemIndex ;
  StoredPropsListBox -> Items ->  Exchange ( Index  , Index + 1 );
  ActionList1 -> ExecuteAction( ActionList1 -> Actions[0] ) ;
}
//---------------------------------------------------------------------------

void __fastcall TStoredPropDlg::TreeViewEditing(TObject *Sender,
      TTreeNode *Node, bool &AllowEdit)
{
  //    
  AllowEdit = false ;
}
//---------------------------------------------------------------------------
void __fastcall TStoredPropDlg::TreeViewMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  //   
  FX = X ;
  FY = Y ;
}
//---------------------------------------------------------------------------
void __fastcall TStoredPropDlg::UpdateListBox()
{
  TTreeNode* Node = TreeView -> Selected ;

  AnsiString StoredPropRecord = Node -> Parent -> Text + "." + Node -> Text  ;

  //    ListBox
  int Index=-1 ;
  for ( int PropIndex = 0 ; PropIndex < StoredPropsListBox->Count ; PropIndex ++ )
   {
     if ( StoredPropsListBox -> Items->Strings[PropIndex].Pos(StoredPropRecord))
      {
       Index = PropIndex ;
       break ;
      }
   }

  AnsiString Flags ;
  switch ( Node->StateIndex )
   {
     case 1:
       {
         StoredPropsListBox -> Items -> Delete(Index) ;

         ActionList1 -> ExecuteAction( ActionList1 -> Actions[0] ) ;
         FXMLPropsStorage->SetPropRecord(Node -> Parent -> Text , Node -> Text , pmRemove , 0 ) ;
         return ;
       }
     case 2: { Flags="-W  " ; break ; }
     case 3: { Flags="R-  " ; break ; }
     case 4: { Flags="RW  " ; break ; }
   }

  if  ( Index==-1 )
    StoredPropsListBox -> Items -> AddObject (Flags + StoredPropRecord , (TObject*)Node -> Parent -> Data ) ;
  else
    StoredPropsListBox -> Items -> Strings[Index] = Flags + StoredPropRecord ;

  ActionList1 -> ExecuteAction( ActionList1 -> Actions[0] ) ;
}
