//---------------------------------------------------------------------------

#ifndef StoredPropEditorH
#define StoredPropEditorH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include <DesignEditors.hpp>
#include <DesignIntf.hpp>

#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <Graphics.hpp>
#include <Buttons.hpp>
#include <ActnList.hpp>
#include "ToolsAPI.hpp"
#include "XMLPropsStorage.h"

namespace Klentoolslibed
{

//---------------------------------------------------------------------------
class PACKAGE TStoredPropDlg : public TForm
{
__published:	// IDE-managed Components
        TImageList *ImageList;
        TTabSheet *ComponentsSheet;
        TTabSheet *StoredPropertiesSheet;
        TPanel *Panel1;
        TPanel *Panel2;
        TPanel *Panel3;
        TPanel *Panel4;
        TPanel *Panel5;
        TRadioGroup *DirectBox;
        TSpeedButton *RemovePropSpeedButton;
        TSpeedButton *UpPropButton;
        TSpeedButton *DownPropButton;
        TTreeView *TreeView;
        TPanel *Panel8;
        TImageList *StateImageList;
        TActionList *ActionList1;
        TAction *Action1;
        TListBox *StoredPropsListBox;
        TImage *Image1;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        void __fastcall FormShow(TObject *Sender);

        void __fastcall ActionList1Execute(TBasicAction *Action, bool &Handled);
        void __fastcall TreeViewClick(TObject *Sender);

        void __fastcall FormHide(TObject *Sender);
        void __fastcall StoredPropsListBoxClick(TObject *Sender);
        void __fastcall RemovePropSpeedButtonClick(TObject *Sender);
        void __fastcall UpPropButtonClick(TObject *Sender);
        void __fastcall DownPropButtonClick(TObject *Sender);
        void __fastcall TreeViewEditing(TObject *Sender, TTreeNode *Node,
          bool &AllowEdit);
        void __fastcall TreeViewMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
private:	// User declarations
        //  
        TComponent* FTarget ;
        //  
        TXMLPropsStorage* FXMLPropsStorage ;
        PPropInfo* FPropInfo ;

        //    
        int FX ;
        int FY ;

        void __fastcall CreateComponentPropInfo ( TComponent* Obj , int* PropCount , PPropInfo** PropInfoList ) ;
        void __fastcall DeleteComponentPropInfo ( PPropInfo* PropInfoList) ;


public:		// User declarations
        __fastcall TStoredPropDlg(TComponent* Owner , TXMLPropsStorage* Component );
        void __fastcall UpdateListBox(void);
        __property TComponent* Target = {read = FTarget , write = FTarget} ;
        __property TXMLPropsStorage* XMLPropsStorage = {read = FXMLPropsStorage , write = FXMLPropsStorage} ;

};
//---------------------------------------------------------------------------
class PACKAGE TXMLPropsStorageEitor: public TComponentEditor
{
public:
    __fastcall TXMLPropsStorageEitor (Classes::TComponent* AComponent, Designintf::_di_IDesigner ADesigner);
    // IDE services
    void __fastcall OnComponentRenamed(void * ComponentHandle, const AnsiString OldName, const AnsiString NewName);

    void __fastcall Edit () ;
    void __fastcall ExecuteVerb(int Index);
    AnsiString __fastcall GetVerb(int Index);
    int __fastcall GetVerbCount(void);
    void __fastcall UpdateComponent () ;
};
}
using namespace Klentoolslibed ;
//---------------------------------------------------------------------------
#endif
