//---------------------------------------------------------------------------
#include <vcl.h>
#include <basepch.h>

#pragma hdrstop

#include "XMLCustomStorage.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//---------------------------------------------------------------------------
static inline void ValidCtrCheck(TXMLCustomStorage *)
{
  new TXMLCustomStorage ((TComponent*)NULL) ;
}
//---------------------------------------------------------------------------
__fastcall TXMLCustomStorage::TXMLCustomStorage(TComponent* Owner) : TComponent(Owner)
{
  XML = NewXMLDocument () ;
  XML -> XML -> Clear() ;
}
//---------------------------------------------------------------------------
__fastcall TXMLCustomStorage::~TXMLCustomStorage()
{

}
//---------------------------------------------------------------------------
OleVariant __fastcall TXMLCustomStorage::GetTagAttribute(AnsiString Tag, AnsiString TagAttribute , Variant DefaultVal )
{
  _di_IXMLNode Node = GetTargetNode ( Tag , false ) ;
  if(!Node) return DefaultVal ;
  if ( Node -> Attributes[TagAttribute].IsNull() ) return DefaultVal ;
  return Node -> Attributes[TagAttribute]  ;
}
//---------------------------------------------------------------------------
double __fastcall TXMLCustomStorage::GetTagAttributeFloat(AnsiString Tag, AnsiString TagAttribute , Variant DefaultVal )
{
  AnsiString Value = GetTagAttribute( Tag,  TagAttribute , DefaultVal ) ;
  //     
  char Buff[2] ;
  DWORD Size = 2 ;
  DWORD Type ;
  HKEY Key = NULL ;
  RegOpenKeyEx( HKEY_CURRENT_USER , "Control Panel\\International" , 0 , KEY_READ , &Key );
  RegQueryValueEx( Key,	"sDecimal", 0 , &Type , Buff , &Size ) ;
  RegCloseKey (Key) ;

  if ( !strcmp ( Buff , "," ))
   {
     int DecimalPosition = Value.Pos(".") ;
     if ( DecimalPosition )
       {
         Value.Delete( DecimalPosition , 1 ) ;
         Value.Insert( Buff , DecimalPosition )   ;
       }
     return Value.ToDouble() ;
   }
  else
   {
     OleVariant Var = Value ;
     return Var ;
   }

}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::SetTagAttribute(AnsiString Tag, AnsiString TagAttribute , Variant AttributeVal , bool AllowCreate )
{
  _di_IXMLNode Node = GetTargetNode ( Tag , AllowCreate ) ;
  if(!Node) return ;
  Node -> Attributes[TagAttribute] = AttributeVal ;
}
//---------------------------------------------------------------------------
OleVariant __fastcall TXMLCustomStorage::GetTagValue(AnsiString Tag , Variant DefaultVal )
{
 _di_IXMLNode Node = GetTargetNode ( Tag , false ) ;
 if(!Node)  return DefaultVal ;
 if ( Node -> NodeValue.IsNull() ) return DefaultVal ;
 return Node -> NodeValue ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::SetTagValue(AnsiString Tag , OleVariant TagVal  , bool AllowCreate )
{
 _di_IXMLNode Node = GetTargetNode ( Tag , AllowCreate ) ;
 if(!Node) return ;
 Node -> NodeValue = TagVal ;
}
//---------------------------------------------------------------------------
DOMString __fastcall TXMLCustomStorage::GetRootTagName ()
{
 return GetTargetNode ( "" , false ) -> NodeName ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::DeleteTagAttributes(AnsiString Tag)
{
 _di_IXMLNode Node = GetTargetNode ( Tag , false ) ;
 if(!Node) return ;

 Node -> AttributeNodes -> Clear() ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::DeleteTagChilds(AnsiString Tag)
{
 _di_IXMLNode Node = GetTargetNode ( Tag , false ) ;
 if(!Node) return ;

 Node -> ChildNodes -> Clear() ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::DeleteTagAttribute(AnsiString Tag , AnsiString TagAttribute )
{
 _di_IXMLNode Node = GetTargetNode ( Tag , false ) ;
 if(!Node) return ;

 Node -> AttributeNodes -> Delete(TagAttribute) ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::GetChildTagNameList ( AnsiString Tag , TStrings* ChildTagNameList )
{
 _di_IXMLNode Node = GetTargetNode ( Tag , false ) ;
 int Count = Node -> ChildNodes -> Count ;
 ChildTagNameList -> Clear() ;
 for ( int NodeCount = 0 ; NodeCount < Count ; NodeCount++ )
  {
   ChildTagNameList -> Add ( Node -> ChildNodes -> Nodes[NodeCount] -> NodeName ) ;
  }
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::GetTagAttributeNameList (AnsiString Tag , TStrings* AttributeNameList )
{
 _di_IXMLNode Node = GetTargetNode ( Tag , false ) ;
 if(!Node) return ;

 for ( int AttributeNameCount = 0 ; AttributeNameCount < Node -> AttributeNodes -> Count ; AttributeNameCount ++ )
  {
    AttributeNameList -> Add ( Node -> AttributeNodes -> Nodes[AttributeNameCount] -> LocalName ) ;
  }
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::GetTagAttributeList (AnsiString Tag , TStrings* AttributeList )
{
 _di_IXMLNode Node = GetTargetNode ( Tag , false ) ;
 if(!Node) return ;

 for ( int AttributeNameCount = 0 ; AttributeNameCount < Node -> AttributeNodes -> Count ; AttributeNameCount ++ )
 AttributeList -> Add ( AnsiString(Node -> AttributeNodes -> Nodes[AttributeNameCount] -> LocalName) + "=" +
                        AnsiString(Node -> AttributeNodes -> Nodes[AttributeNameCount] -> NodeValue )) ;
}
//---------------------------------------------------------------------------
_di_IXMLNode  __fastcall TXMLCustomStorage::GetTargetNode ( AnsiString TargetTag , bool AllowCreate )
{
  AnsiString TagName ;
  AnsiString LastTarget ;
  if ( TargetTag.IsEmpty() ) return XML -> DocumentElement ;

  if ( TargetTag.Pos("\\") )
   {
    TagName = TargetTag.SubString(1,TargetTag.Pos("\\") - 1);
    LastTarget = TargetTag.SubString(TargetTag.Pos("\\") + 1 , TargetTag.Length());
   }
   else
   {
    TagName = TargetTag ;
    LastTarget = "" ;
   }

  //     
  _di_IXMLNode  Node = XML -> DocumentElement -> ChildNodes -> FindNode ( TagName ) ;
  if ( !Node )
    {
      if ( AllowCreate )
      //    -  
      Node = DocumentElement -> AddChild ( TagName , -1 ) ;
      else
       {
        if ( AbsentTagExcept  ) throw Exception("TXMLStorage: tag " + TargetTag + " is not present in XML document " + FileName) ;
        return NULL ;
       }
    }

  while ( !LastTarget.IsEmpty() )
    {
     if ( LastTarget.Pos("\\") )
      {
       TagName = LastTarget.SubString( 1 , LastTarget.Pos("\\") - 1 ) ;
       LastTarget = LastTarget.SubString(LastTarget.Pos("\\") + 1 , LastTarget.Length()) ;
      }
     else
      {
       TagName = LastTarget ;
       LastTarget = "" ;
      }
     _di_IXMLNode TmpNode = Node ;
     Node = Node -> ChildNodes -> FindNode ( TagName )  ;
     if ( !Node )
     {
      if ( AllowCreate )
      //    -  
      Node = TmpNode -> AddChild ( TagName , -1 ) ;
      else
        {
         if ( AbsentTagExcept  ) throw Exception("TXMLStorage: tag " + TargetTag + " is not present in XML document " + FileName) ;
         return NULL ;
        }
      }
    }

   return Node ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::SetActive(bool value)
{
  XML -> Active = value ;
}
//---------------------------------------------------------------------------
bool __fastcall TXMLCustomStorage::GetActive()
{
   return XML -> Active ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::SetFileName(WideString value)
{
  XML -> FileName = value ;
}
//---------------------------------------------------------------------------
WideString __fastcall TXMLCustomStorage::GetFileName()
{
  return XML -> FileName ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::SetDocumentElement(_di_IXMLNode value)
{
  XML -> DocumentElement = value ;
}
//---------------------------------------------------------------------------
_di_IXMLNode __fastcall TXMLCustomStorage::GetDocumentElement()
{
  return XML -> DocumentElement ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::SetNodeIndentStr(DOMString value)
{
  XML -> NodeIndentStr = value ;
}
//---------------------------------------------------------------------------
DOMString __fastcall TXMLCustomStorage::GetNodeIndentStr()
{
  return XML -> NodeIndentStr ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::SetOptions ( TXMLDocOptions val )
{
   XML -> Options = val  ;
}
 TXMLDocOptions __fastcall TXMLCustomStorage::GetOptions ()
{
   return  XML -> Options ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::SetParseOptions(TParseOptions value)
{
  XML -> ParseOptions = value ;
}
//---------------------------------------------------------------------------
TParseOptions __fastcall TXMLCustomStorage::GetParseOptions()
{
  return XML -> ParseOptions ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::CreateXMLFile(AnsiString XMLFileName , AnsiString CodePage , AnsiString RootTag ,
                                                 AnsiString Comment )
{
  TStringList* XMLContent = new TStringList () ;
  if ( RootTag.IsEmpty() ) RootTag = "Root" ;

  if (CodePage.IsEmpty()) CodePage = "windows-1251" ;
  if (Comment.IsEmpty()) Comment = "TXMLStorage component saved data file" ;
  XMLContent -> Add ("<?xml version='1.0' encoding=\"" + CodePage + "\" ?><!-- " + Comment +" --><" + RootTag +"/>") ;
  try
   {
     XMLContent ->  SaveToFile(XMLFileName) ;
   }
  catch ( Exception &E )
   {
     ShowMessage ( E.Message ) ;
   }
  delete XMLContent ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::ClearRootTag()
{
 _di_IXMLNode Node = DocumentElement ;
 if ( !Node )
  {
   if ( AbsentTagExcept  ) throw Exception("TXMLStorage: root XML document tag is not present in XML document " + FileName) ;
   else return ;
  }

 //   
 Node -> ChildNodes -> Clear() ;
 //   
 Node -> AttributeNodes -> Clear() ;
 //  
 OleVariant NullResult  ;
 NullResult.VType =  varNull ;
 Node -> NodeValue = NullResult ;
}
//---------------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::ClearTag( AnsiString Tag)
{
 _di_IXMLNode Node = GetTargetNode ( Tag , false ) ;
 if ( !Node )
  {
   if ( AbsentTagExcept  ) throw Exception("TXMLStorage: tag " + Tag + " is not present in XML document " + FileName) ;
   else return  ;
  }

 //   
 Node -> ChildNodes -> Clear() ;
 //   
 Node -> AttributeNodes -> Clear() ;
 //  
 OleVariant NullResult  ;
 NullResult.VType =  varNull ;
 Node -> NodeValue = NullResult ;
}
//---------------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::DeleteTag(AnsiString Tag)
{
 _di_IXMLNode Node = GetTargetNode ( Tag , false ) ;
 if(!Node) return ;
 _di_IXMLNode ParentNode = Node -> ParentNode ;
 ParentNode -> ChildNodes -> Remove (Node) ;
}
//---------------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::DeleteTagValue (AnsiString Tag)
{
  OleVariant NullResult ;
  NullResult.VType =  varNull  ;
  SetTagValue ( Tag , NullResult , false ) ;
}
//---------------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::DeleteEmptyChilds (_di_IXMLNode ParentNode )
{
  for ( int Index = 0 ; Index < ParentNode->ChildNodes->Count ; Index++ )
  {
    _di_IXMLNode Node = ParentNode->ChildNodes->Nodes[Index] ;

    if (Node->NodeName.IsEmpty()) continue ;

    DeleteEmptyChilds ( Node ) ;
    if ( !Node->ChildNodes->Count && (Node->NodeValue.VType == varNull) && !Node->AttributeNodes->Count )
     {
      ParentNode->ChildNodes->Delete(Index) ;
      Index -- ;
     }
  }
}
//---------------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::DeleteEmptyTags ()
{
 for ( int Index = 0 ; Index < XML->DocumentElement->ChildNodes->Count ; Index++ )
  {
    _di_IXMLNode Node = XML->DocumentElement->ChildNodes->Nodes[Index] ;

    if (Node->NodeName.IsEmpty()) continue ;

    DeleteEmptyChilds ( Node ) ;
    if ( !Node->ChildNodes->Count && (Node->NodeValue.VType == varNull) && !Node->AttributeNodes->Count )
     {
      DocumentElement->ChildNodes->Delete(Index) ;
      Index -- ;
     }
  }
}
//---------------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::Save ()
{
  XML -> SaveToFile (XML -> FileName ) ;
}
//---------------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::SaveToFile (DOMString DestFileName)
{
  XML -> SaveToFile (DestFileName) ;
}
//---------------------------------------------------------------------------------
void __fastcall TXMLCustomStorage::LoadFromFile (DOMString DestFileName)
{
  XML -> LoadFromFile (DestFileName) ;
}

