//---------------------------------------------------------------------------

#ifndef XMLCustomStorageH
#define XMLCustomStorageH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>

#include <XMLDoc.hpp>

namespace Klentoolslib
{

//---------------------------------------------------------------------------
class PACKAGE TXMLCustomStorage : public TComponent
{
private:
        //    XML
        _di_IXMLDocument XML ;
        //        
        bool FAbsentTagExcept;

        void __fastcall SetActive(bool value);
        bool __fastcall GetActive();

        void __fastcall SetFileName(WideString value);
        WideString __fastcall GetFileName();

        void __fastcall SetDocumentElement(_di_IXMLNode value);
        _di_IXMLNode __fastcall GetDocumentElement();

        void __fastcall SetDOMVendor(TDOMVendor* value);
        TDOMVendor* __fastcall GetDOMVendor();

        void __fastcall SetNodeIndentStr(DOMString value);
        DOMString __fastcall GetNodeIndentStr();

        void __fastcall SetOptions ( TXMLDocOptions val );
        TXMLDocOptions __fastcall GetOptions () ;

        void __fastcall SetParseOptions(TParseOptions value);
        TParseOptions __fastcall GetParseOptions();

        //      XML 
        _di_IXMLNode  __fastcall GetTargetNode ( AnsiString TargetTag , bool AllowCreate ) ;
        void __fastcall TXMLCustomStorage::DeleteEmptyChilds (_di_IXMLNode Node ) ;

protected:
        __property _di_IXMLNode DocumentElement  = { read=GetDocumentElement, write=SetDocumentElement };
        __property WideString FileName  = { read=GetFileName, write=SetFileName };
        __property DOMString NodeIndentStr  = { read=GetNodeIndentStr, write=SetNodeIndentStr };
        __property TParseOptions ParseOptions  = { read=GetParseOptions, write=SetParseOptions };
        __property bool Active  = { read=GetActive, write=SetActive };
        __property bool AbsentTagExcept  = { read=FAbsentTagExcept, write=FAbsentTagExcept };
        __property TXMLDocOptions Options  = { read=GetOptions, write=SetOptions };
public:
        __fastcall TXMLCustomStorage(TComponent* Owner);
        __fastcall ~TXMLCustomStorage();

                ///  
        OleVariant __fastcall GetTagAttribute(AnsiString Tag, AnsiString TagAttribute , Variant DefaultVal );
        // $$  25.02.05
        //      
        double __fastcall GetTagAttributeFloat(AnsiString Tag, AnsiString TagAttribute , Variant DefaultVal );
        void __fastcall SetTagAttribute(AnsiString Node, AnsiString TagAttribute , Variant AttributeVal , bool AllowCreate );

        ///  
        OleVariant __fastcall GetTagValue(AnsiString Tag , Variant DefaultVal );
        void __fastcall SetTagValue (AnsiString Tag, OleVariant TagVal , bool AllowCreate );

        //    
        DOMString __fastcall GetRootTagName () ;

        //   
        void __fastcall DeleteTagAttributes(AnsiString Tag);
        //   
        void __fastcall DeleteTagAttribute(AnsiString Tag , AnsiString TagAttribute );
        //  
        void __fastcall DeleteTagValue(AnsiString Tag );
        //   
        void __fastcall DeleteTagChilds (AnsiString Tag ) ;
        //     -       
        void __fastcall DeleteEmptyTags () ;

        //     
        void __fastcall GetChildTagNameList ( AnsiString Tag , TStrings* ChildTagNameList ) ;
        //     
        void __fastcall GetTagAttributeNameList (AnsiString Tag , TStrings* AttributeNameList ) ;
        //       AttributeName=Value
        void __fastcall GetTagAttributeList (AnsiString Tag , TStrings* AttributeList ) ;

        //  XML 
        void __fastcall CreateXMLFile(AnsiString XMLFileName , AnsiString CodePage , AnsiString RootTag , AnsiString Comment );

        //  
        void __fastcall DeleteTag (AnsiString Tag);
        //     ( , ,  )
        void __fastcall ClearRootTag();
        //          ( , ,  )
        void __fastcall ClearTag (AnsiString Tag ) ;
        //    
        void __fastcall Save () ;

        //  XML   
        void __fastcall SaveToFile (DOMString) ;
        //  XML   
        void __fastcall LoadFromFile (DOMString) ;
};

}

using namespace Klentoolslib ;
//---------------------------------------------------------------------------
#endif
