//---------------------------------------------------------------------------

#include <vcl.h>
#include <basepch.h>

#pragma hdrstop

#include "XMLPropsStorage.h"

#pragma package(smart_init)
//---------------------------------------------------------------------------
static inline void ValidCtrCheck(TXMLPropsStorage *)
{
  new TXMLPropsStorage(NULL);
}
//---------------------------------------------------------------------------
__fastcall TXMLPropsStorage::TXMLPropsStorage(TComponent* Owner)
        : TComponent(Owner)
{
  VNull.VType = varNull ;
  //    
  FXMLStorage  = new TXMLStorage  (this) ;
  FDataConvertor = new TDataConverter (this);
  FStoredProps = new TStringList  () ;


  FXMLStorageInitNeeded = true ;
  FIOMutex = NULL ;
  FIsReadNeeded = true ;
  FIsWriteNeeded = true ;

  //     
  FActive = true ;
  Application -> HookMainWindow (AppWindowHook) ;
  
  FDirect = sdLifo   ;
}
//---------------------------------------------------------------------------
__fastcall TXMLPropsStorage::~TXMLPropsStorage()
{
  Active = false ;
  CloseHandle ( FIOMutex ) ;
  delete FStoredProps ;
}
//---------------------------------------------------------------------------
bool __fastcall TXMLPropsStorage::AppWindowHook ( TMessage& Message )
{
  if ( (Application -> Terminated == false) && (FIsReadNeeded) )
     {
       //          DFM
       FIsReadNeeded = false ;
       ReadProps () ;
     }
  if ( Application -> Terminated && FIsWriteNeeded )
     {
       //      XML 
       FIsWriteNeeded = false ;
       WriteProps () ;
     }
  return false ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::SetActive (bool val)
{
  FActive = val  ;
  if ( FIsReadNeeded ) FIsReadNeeded = false ;
  if ( FActive )
   {
     Application -> HookMainWindow (AppWindowHook) ;
   }
  else
   {
     Application -> UnhookMainWindow (AppWindowHook) ;
   }
}
//---------------------------------------------------------------------------
TXMLDocOptions __fastcall TXMLPropsStorage::GetOptions ()
{
  return FXMLStorage -> Options ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::SetOptions (TXMLDocOptions val)
{
  FXMLStorage -> Options = val ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::LoadBoolProperty(TReader *Reader)
{
  FDirect = Reader -> ReadBoolean () ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::StoreBoolProperty(TWriter *Writer)
{
  Writer -> WriteBoolean(FDirect) ;
}
//---------------------------------------------------------------------------
void __fastcall  TXMLPropsStorage::LoadStringsProperty(TReader *Reader)
{
  FStoredProps -> Text = Reader -> ReadString () ;
}
//---------------------------------------------------------------------------
void __fastcall  TXMLPropsStorage::StoreStringsProperty(TWriter *Writer)
{
  Writer -> WriteString ( FStoredProps -> Text ) ;
}
//---------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::DefineProperties(TFiler *Filer)
{
  TComponent::DefineProperties(Filer);
  if ( FXMLStorageInitNeeded )
   {
     InitXMLPropsStorage () ;
     FXMLStorage -> AbsentTagExcept = false ;
     //    InitXMLPropsStorage ()
     FXMLStorageInitNeeded = false ;
   }
  Filer -> DefineProperty("FDirect",LoadBoolProperty,StoreBoolProperty, true);
  Filer -> DefineProperty("FStoredProps",LoadStringsProperty,StoreStringsProperty, true);
}
//---------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::SetFileName(AnsiString val)
{
  //    
  FXMLStorage -> FileName = val ;

  //       
  AnsiString Dir = ExtractFileDir (val) ;
  if ( !DirectoryExists ( Dir ) )
     CreateDir (Dir) ;

  if ( !FileExists(val))
     FXMLStorage->CreateXMLFile( FXMLStorage -> FileName , "windows-1251" , "ComponentStorage" , "TXMLPropsStorage component XML data file."  ) ;

  //   
  CloseHandle ( FIOMutex ) ;
  //      
  FSynchronizeObject = "KLEN_LIB_SYNCHRO_OBJ_" + ExpandFileName ( FXMLStorage -> FileName ) ;

  //      
  while ( FSynchronizeObject.Pos("\\") )
    {
     int BackSlashPos  =  FSynchronizeObject.Pos("\\") ;
     FSynchronizeObject = FSynchronizeObject.Delete( BackSlashPos , 1 )  ;
     FSynchronizeObject = FSynchronizeObject.Insert( "_" , BackSlashPos )  ;
    }

  if ( FSynchronizeObject.Length() >= MAX_PATH )
       FSynchronizeObject.SetLength (MAX_PATH) ;
  //    
  FIOMutex = CreateMutex ( NULL , false , FSynchronizeObject.c_str() ) ;
  if ( !FIOMutex )
   {
     throw Exception ( SysErrorMessage (GetLastError()) ) ;
   }
 }
//--------------------------------------------------------------------------
AnsiString __fastcall TXMLPropsStorage::GetFileName()
{
  return  FXMLStorage -> FileName ;
}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::WriteProps()
{
   if ( FileName.IsEmpty() ) return ;
   //      
   if ( FOnBeginStore ) FOnBeginStore (this) ;
   //         
   WaitForSingleObject (FIOMutex , INFINITE);
   try
   {
   FXMLStorage -> Active = true ;

   //   RW-.
   for ( int StoredPropListItem = 0 ; StoredPropListItem < FStoredProps -> Count ; StoredPropListItem ++ )
   {
     AnsiString ComponentName     ;
     AnsiString PropName ;
     TPropMode  Mode        ;
     try
       {
        UnPackPropInfo ( FStoredProps -> Strings[StoredPropListItem] , ComponentName , PropName , Mode ) ;
       }
     catch (...)
       {
        //    -        
        SetPropRecord ( ComponentName , PropName , pmRemove , 0 ) ;
        continue ;
       }
     if ( Mode != pmWrite && Mode != pmReadWrite  ) continue ;

     //--------------------------------------------------

     TComponent* Obj = NULL ;
     if ( ComponentName == Owner -> Name )
        Obj = Owner ;


     bool RootObj = true ;
     if ( !Obj )
      {
       Obj =  Owner -> FindComponent ( ComponentName ) ;
       RootObj = false ;
      }
     if ( !Obj ) continue ;

     TPropInfo* Info = GetPropInfo( (TTypeInfo*)Obj -> ClassInfo() , PropName ) ;
     int Kind = tkUnknown ;
     //   
     if ( IsPublishedProp( Obj , PropName ))
      {
       //  
       try { Kind = PropType( Obj , PropName ) ; }
       catch (Exception& Exc ) { continue ; }
      }
     else
      {
       //  
       Kind = tkUnpublished ;
      }

    AnsiString OwnerComponentName = "" ;
    if ( !RootObj )
     {
       OwnerComponentName = Obj -> Owner -> Name + "\\";
     }
     switch ( Kind )
       {
         case tkUnknown :  continue ;
         case tkMethod  :
            {
               WriteTMethod ( OwnerComponentName , Obj , Info , msmGeneral ) ;
               break ;
            }
         case tkUnpublished :    //    
            {
               //    TStringGrid
               if ( dynamic_cast < TStringGrid* >(Obj) )
                 {
                  if ( PropName == "Cells" )
                    {  //   Cells
                      WriteStringGridUnpublishedProp ( OwnerComponentName , dynamic_cast < TStringGrid* >(Obj) , PropName ) ;
                      break ;
                    }
                 }
             }
         case tkClass   :
            {
               TPersistent* Prop = (TPersistent*)(int)GetPropValue ( Obj , PropName );
               //  TStrings
               if ( KlenUtils::IsReducibleProp ( __classid (TStrings) , Info ) )
                 {
                  WriteTStringsProp ( OwnerComponentName , Obj , dynamic_cast < TStrings* >(Prop) , Info  ) ;
                 break ;
                 }
               if ( KlenUtils::IsReducibleProp ( __classid (TPicture) , Info ) )
                 {
                  WriteTPictureProp ( OwnerComponentName , Obj , dynamic_cast < TPicture*>(Prop)  , Info ) ;
                  break ;
                 }
               if ( KlenUtils::IsReducibleProp ( __classid (TFont) , Info ) )
                 {
                  WriteTFontProp ( OwnerComponentName , Obj , dynamic_cast < TFont*>(Prop)  , Info ) ;
                  break ;
                 }
               if ( KlenUtils::IsReducibleProp ( __classid (TTreeNodes) , Info ) )
                 {
                  WriteTTreeNodesProp ( OwnerComponentName , Obj , dynamic_cast < TTreeNodes*>(Prop)  , Info ) ;
                  break ;
                 }
               if ( KlenUtils::IsReducibleProp ( __classid (TMenuItem) , Info ) )
                 {
                  WriteTMenuItemProp ( OwnerComponentName , Obj , dynamic_cast < TMenuItem*>(Prop)  , Info ) ;
                  break ;
                 }
               if ( KlenUtils::IsReducibleProp ( __classid (TComponent) , Info ) )
                 {
                  WriteTComponentProp ( OwnerComponentName , Obj , dynamic_cast < TComponent*>(Prop)  , Info ) ;
                  break ;
                 }
               //   ,    
               // .
               continue ;
            }
         default:
            {
               //      
               Variant Val ;
               Val = GetPropValue ( Obj , PropName )  ;

               if ( AnsiString((*(Info -> PropType)) -> Name) == "TColor" )
                {
                  Val = ColorToString ( (TColor)(int)Val ) ;
                }

               FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  PropName , "Val"  , Val , true );
            }
         }

     if ( FOnStorePropPassed ) FOnStorePropPassed (this , StoredPropListItem ,  OwnerComponentName + Obj -> Name + "\\" +  AnsiString(Info -> Name) ) ;
   }
  FXMLStorage -> Save () ;
  FXMLStorage -> Active = false ;
  } catch (...) {}
  //         
  ReleaseMutex (FIOMutex) ;
  if ( FOnEndStore ) FOnEndStore (this) ;
}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::ReadProps()
{
   if ( FileName.IsEmpty() ) return ;
   //      
   if ( FOnBeginRestore ) FOnBeginRestore (this) ;
   //         
   WaitForSingleObject (FIOMutex , INFINITE) ;
   try
   {
   FXMLStorage -> Active = true ;

   //    
   TStringList* RestoredPropList = new TStringList () ;
   if ( FDirect == sdLifo )
     {
       for  ( int StoredProp = FStoredProps -> Count - 1 ; StoredProp > -1 ; StoredProp -- )
        {
          RestoredPropList -> Add ( FStoredProps -> Strings[StoredProp] )  ;
        }
     }
   else
     {
       RestoredPropList -> AddStrings ( FStoredProps ) ;
     }

   //    
   for ( int RestoredPropListItem = 0 ; RestoredPropListItem < RestoredPropList -> Count ; RestoredPropListItem ++ )
   {
     AnsiString ComponentName     ;
     AnsiString PropName ;
     TPropMode  Mode        ;
     try
       {
        UnPackPropInfo ( RestoredPropList -> Strings[RestoredPropListItem] , ComponentName , PropName , Mode ) ;
       }
     catch (...)
       {
        //    -         
        SetPropRecord ( ComponentName , PropName , pmRemove , 0 ) ;
        continue ;
       }
     if ( Mode != pmRead && Mode != pmReadWrite  ) continue ;

     //--------------------------------------------------
     TComponent* Obj = NULL ;
     if ( ComponentName == Owner -> Name )
        Obj = Owner ;

     bool RootObj = true ;
     if ( !Obj )
      {
       Obj =  Owner -> FindComponent ( ComponentName ) ;
       RootObj = false ;
      }
     if ( !Obj ) continue ;


     TPropInfo* Info = GetPropInfo( (TTypeInfo*)Obj -> ClassInfo() , PropName ) ;
     int Kind = tkUnknown ;
     //   
     if ( IsPublishedProp( Obj , PropName ))
      {
       //  
       try { Kind = PropType( Obj , PropName ) ; }
       catch (Exception& Exc ) { continue ; }
      }
     else
      {
       //  
       Kind = tkUnpublished ;
      }

     AnsiString OwnerComponentName = "" ;
     if (  !RootObj )
      {
       OwnerComponentName = Obj -> Owner -> Name + "\\" ;
      }
     //     
     switch ( Kind )
       {
         case tkMethod :
            {
               ReadTMethod ( OwnerComponentName , Obj , Info , msmGeneral ) ;
               break ;
            }
                  case tkUnpublished :    //    
            {
               //    TStringGrid
               if ( dynamic_cast < TStringGrid* >(Obj) )
                 {
                  if ( PropName == "Cells" )
                    {  //   Cells
                      ReadStringGridUnpublishedProp ( OwnerComponentName , dynamic_cast < TStringGrid* >(Obj) , PropName ) ;
                      break ;
                    }
                 }
             }
         case tkClass  :
            {
               //  
               TPersistent* Prop = (TPersistent*)(int)GetPropValue ( Obj , PropName );
               if ( KlenUtils::IsReducibleProp ( __classid (TStrings) , Info ) )
                 {
                  ReadTStringsProp ( OwnerComponentName , Obj , dynamic_cast < TStrings* >(Prop) , Info ) ;
                  break ;
                 }
               if ( KlenUtils::IsReducibleProp ( __classid (TPicture) , Info ) )
                 {
                  ReadTPictureProp ( OwnerComponentName , Obj , dynamic_cast < TPicture*>(Prop)  , Info ) ;
                  break ;
                 }
               if ( KlenUtils::IsReducibleProp ( __classid (TFont) , Info ) )
                 {
                  ReadTFontProp ( OwnerComponentName , Obj , dynamic_cast < TFont*>(Prop)  , Info ) ;
                  break ;
                 }
               if ( KlenUtils::IsReducibleProp ( __classid (TTreeNodes) , Info ) )
                 {
                  ReadTTreeNodesProp ( OwnerComponentName , Obj , dynamic_cast < TTreeNodes*>(Prop)  , Info ) ;
                  break ;
                 }
               if ( KlenUtils::IsReducibleProp ( __classid (TMenuItem) , Info )  )
                 {
                  ReadTMenuItemProp ( OwnerComponentName , Obj , dynamic_cast < TMenuItem*>(Prop)  , Info ) ;
                  break ;
                 }
               //  TComponent
               if ( KlenUtils::IsReducibleProp ( __classid (TComponent) , Info )  )
                 {
                  ReadTComponentProp ( OwnerComponentName , Obj , dynamic_cast < TComponent*>(Prop)  , Info ) ;
                  break ;
                 }

               //   ,    
               // .
               continue ;
            }
         default:
            {
                //      
               OleVariant PreVal = FXMLStorage -> GetTagAttribute( OwnerComponentName + Obj -> Name + "\\" +  AnsiString(Info -> Name) , "Val" , VNull ) ;

               if ( PreVal.IsNull() )
                {
                 //    ,   
                 continue ;
                }

               //  
               if ( AnsiString((*(Info -> PropType)) -> Name) == "TColor" )
                {
                   PreVal = StringToColor (PreVal) ;
                }

               // $$  25.02.05
               //      
               if ( Kind != tkFloat )
                {
                  SetPropValue ( Obj , AnsiString(Info -> Name) , AnsiString(PreVal) )  ;
                }
               else
                {
                  double PreFloatVal = FXMLStorage -> GetTagAttributeFloat( OwnerComponentName + Obj -> Name + "\\" +  AnsiString(Info -> Name) , "Val" , VNull ) ;
                  SetFloatProp( Obj, AnsiString(Info -> Name) , PreFloatVal ) ;
                }
            }
       }
    if ( FOnRestorePropPassed ) FOnRestorePropPassed (this , RestoredPropListItem ,  OwnerComponentName + Obj -> Name + "\\" +  AnsiString(Info -> Name) ) ;
   }

  delete RestoredPropList ;
  FXMLStorage -> Active = false ;
  } catch (...) {}
  //         
  ReleaseMutex (FIOMutex) ;
  if ( FOnEndRestore ) FOnEndRestore (this) ;
}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::UnPackPropInfo ( AnsiString DataString , AnsiString& Component , AnsiString& Prop , TPropMode& Mode )
{
  AnsiString Tmp = DataString.SubString(1,2) ;
  if ( Tmp == "R-" ) Mode = pmRead ;
  else if ( Tmp == "-W" ) Mode = pmWrite ;
       else  if ( Tmp == "RW" ) Mode = pmReadWrite ;
             else throw  EXMLPropsStorage ("  XMLPropsStorage:\r\n   " ) ;
  if ( !DataString.Pos(".") ) throw EXMLPropsStorage ("  XMLPropsStorage:\r\n   " ) ;
  DataString = DataString.Delete(1,4) ;
  Component = DataString.SubString(1,DataString.Pos(".")-1) ;
  Prop = DataString.SubString(DataString.Pos(".")+1 , DataString.Length()) ;
}
//--------------------------------------------------------------------------
AnsiString __fastcall TXMLPropsStorage::PackPropInfo ( AnsiString Component , AnsiString PropName , TPropMode Mode )
{
  AnsiString Info = Component + "." + PropName ;
  switch ( Mode )
   {
     case  pmRead      :  { Info = "R-  " + Info ; break ; }
     case  pmWrite     :  { Info = "-W  " + Info ; break ; }
     case  pmReadWrite :  { Info = "RW  " + Info ; break ; }
     default : throw EXMLPropsStorage ("  XMLPropsStorage:\r\n  TPropMode Mode=" + Mode ) ;
   }
  return Info ;
}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::SetPropRecord( AnsiString Component , AnsiString PropName , TPropMode Mode , int ListIndex )
{
  //      
  AnsiString ComponentTagName ;
  TComponent* Comp = Owner->FindComponent( Component ) ;
  if ( !Comp )
   {
     if ( Owner->Name == Component )
       {
        Comp = Owner ;
        ComponentTagName = Comp->Name ;
       }
   }
  else ComponentTagName = Comp->Owner->Name + "\\" + Comp->Name ;

  if ( !Comp ) throw EXMLPropsStorage ("  XMLPropsStorage:\r\n     " + Component )  ;

  if ( !IsPublishedProp( Comp , PropName ))
    {
      //      
      if (  !(dynamic_cast<TStringGrid*>(Comp) && PropName=="Cells") )
        throw EXMLPropsStorage ("  XMLPropsStorage:\r\n   ()\\  " + PropName + " " + Component ) ;
    }

  int RecordIndex = -1 ;
  //   
  for (int Index = 0 ;Index < FStoredProps->Count ; Index ++ )
   {
     if ( FStoredProps->Strings[Index].Pos(Component+ "." + PropName) )
      {
        RecordIndex = Index ;
        break ;
      }
   }


  //  
  switch ( Mode )
   {
     case pmRemove :
      {
       //  
       if ( RecordIndex != -1 ) FStoredProps->Delete(RecordIndex) ;
       //    XML 
       FXMLStorage->Active = true ;
       FXMLStorage->DeleteTag( ComponentTagName + "\\" + PropName ) ;
       FXMLStorage->DeleteEmptyTags() ;
       FXMLStorage->Save();
       FXMLStorage->Active = false;
       break ;
      }
     case pmRead :
      {
       // / 
       if ( RecordIndex )  FStoredProps->Strings[RecordIndex] =  PackPropInfo ( Component , PropName , pmRead ) ;
       else
          {
           if (ListIndex == -1) FStoredProps->Add ( PackPropInfo ( Component , PropName , pmRead )) ;
           else FStoredProps->Insert ( ListIndex , PackPropInfo ( Component , PropName , pmRead ) ) ;
          }
       break ;
      }
     case pmWrite :
      {
       // / 
       if ( RecordIndex )  FStoredProps->Strings[RecordIndex] =  PackPropInfo ( Component , PropName , pmWrite ) ;
       else
          {
           if (ListIndex == -1) FStoredProps->Add ( PackPropInfo ( Component , PropName , pmWrite )) ;
           else FStoredProps->Insert (  ListIndex , PackPropInfo ( Component , PropName , pmWrite )) ;
          }
       break ;
      }
     case pmReadWrite :
      {
       // / 
       if ( RecordIndex )  FStoredProps->Strings[RecordIndex] =  PackPropInfo ( Component , PropName , pmReadWrite ) ;
       else
          {
           if (ListIndex == -1) FStoredProps->Add ( PackPropInfo ( Component , PropName , pmReadWrite )) ;
           else FStoredProps->Insert ( ListIndex , PackPropInfo ( Component , PropName , pmReadWrite ) ) ;
          }
       break ;
      }
     default :   throw EXMLPropsStorage ("  XMLPropsStorage:\r\n  TPropMode Mode=" + Mode ) ;
   }
}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::GetPropRecord ( AnsiString Component , AnsiString PropName , TPropMode& Mode )
{
  Mode = pmRemove ;
  //   
  for (int Index = 0 ;Index < FStoredProps->Count ; Index ++ )
   {
     if ( FStoredProps->Strings[Index].Pos(Component+ "." + PropName) )
      {
        AnsiString Tmp ;
        UnPackPropInfo ( FStoredProps->Strings[Index] , Tmp , Tmp , Mode )  ;
        return ;
      }
   }
}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::GetPropList ( TStringList* Props )
{
  Props->Clear();
  for (int Index = 0 ; Index < FStoredProps->Count ; Index ++ )
   {
     AnsiString Component ;
     AnsiString PropName  ;
     TPropMode  Mode      ;
     UnPackPropInfo ( FStoredProps->Strings[Index] , Component , PropName , Mode )  ;
     Props->AddObject ( Component + "." + PropName , (TObject*) Mode ) ;
   }
}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::WriteTMethod ( AnsiString OwnerComponentName , TComponent* Obj , TPropInfo* Info  , TMethodStoredMode Mode )
{
 TMethod StoredMethod = {0,0} ;
 AnsiString HandlerName ;

 StoredMethod = GetMethodProp ( Obj , Info -> Name ) ;

 //    ,   HandlerObject.HandlerName="Undefine" ;
 if ( !StoredMethod.Code || !StoredMethod.Data )
   {
    HandlerName = "Undefine" ;
   }
 else
   {
    //      
    AnsiString ObjName    = ((TComponent*)StoredMethod.Data) -> Name  ;
    AnsiString MethodName = ((TComponent*)StoredMethod.Data) -> MethodName (StoredMethod.Code) ;
    HandlerName = ObjName + "." + MethodName ;

    //  Object MethodName    (     )
    //    
    //     -  
    if ( ObjName.IsEmpty() || MethodName.IsEmpty())
       return ;
   }

 AnsiString MethodTag ;
 switch  ( Mode )
  {
    case msmGeneral :
      {
       MethodTag = OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name ;
       break ;
      }
    case msmMenuItem :
      {
       MethodTag = OwnerComponentName + Info -> Name ;
      }
  }

 FXMLStorage -> SetTagAttribute( MethodTag , "Val"  , HandlerName , true );
}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::ReadTMethod ( AnsiString OwnerComponentName , TComponent* Obj , TPropInfo* Info , TMethodStoredMode Mode )
{
  TMethod StoredMethod ;

  AnsiString MethodTag ;
  switch  ( Mode )
  {
    case msmGeneral :
      {
       MethodTag = OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name ;
       break ;
      }
    case msmMenuItem :
      {
       MethodTag = OwnerComponentName +  Info -> Name ;
      }
  }

  TMethod RestoredMethod = {0,0};

  OleVariant PreVal = FXMLStorage -> GetTagAttribute( MethodTag , "Val"  , VNull ) ;
  //      ,    
  if ( PreVal.IsNull() ) return ;

  //       HandlerObject.HandlerName="Undefine",   
  AnsiString RestoredMethodName = PreVal ;
  if ( AnsiString(PreVal) != "Undefine" )
   {
     //       HandlerObject.HandlerName="Object.Handler",   
     //  Object.Handler       ,    
     RestoredMethod.Data = FindGlobalComponent ( RestoredMethodName.SubString(1 , RestoredMethodName.Pos(".") - 1) ) ;
     if ( !RestoredMethod.Data ) return ;
     RestoredMethod.Code = ((TComponent*)RestoredMethod.Data) -> MethodAddress ( RestoredMethodName.SubString( RestoredMethodName.Pos(".") + 1 , RestoredMethodName.Length() )) ;
     if ( !RestoredMethod.Code ) return ;
   }

  SetMethodProp ( Obj , Info->Name , RestoredMethod ) ;

}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::WriteTStringsProp   ( AnsiString OwnerComponentName , TComponent* Obj , TStrings* Prop , TPropInfo* Info )
{
  if (!Prop) return ;
  //  TStrings
  FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name + "\\LineCount" , "Val" , Prop -> Count , true );
  for ( int Count = 0 ; Count < Prop -> Count ; Count++ )
   {
    FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" + Info -> Name + "\\Item" + AnsiString(Count) , "ItemVal" , Prop -> Strings[Count] , true );
   }
}
void __fastcall TXMLPropsStorage::ReadTStringsProp   ( AnsiString OwnerComponentName , TComponent* Obj , TStrings* Prop , TPropInfo* Info )
{
  try
    {
     //  TStrings
     Prop -> Clear() ;
     //  TStrings
     OleVariant PreVal = FXMLStorage -> GetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name + "\\LineCount" , "Val" , VNull );
     if ( PreVal.IsNull() )
      {
       //    ,   
       return ;
      }
     int LineCount = PreVal.VInteger ;
     for ( int Count = 0 ; Count < LineCount ; Count++ )
      {
       OleVariant PreVal = FXMLStorage -> GetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" + Info -> Name + "\\Item" + AnsiString(Count) , "ItemVal" , VNull ) ;
       if ( PreVal.IsNull() )
        {
         //    ,   
         return ;
        }
       Prop -> Add( PreVal ) ;
      }
    }
  catch (Exception& Excp )
    {

    }
}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::WriteTComponentProp ( AnsiString OwnerComponentName , TComponent* Obj , TComponent* Prop , TPropInfo* Info )
{
  if ( AnsiString(Info -> Name).IsEmpty()) return ;
  if ( Prop )
     FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "Val" , Prop -> Name , true );
  else
     FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "Val" , NULL , true );
}
//--------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::ReadTComponentProp ( AnsiString OwnerComponentName , TComponent* Obj , TComponent* Prop , TPropInfo* Info )
{
  OleVariant PreVal = FXMLStorage -> GetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "Val" , VNull );
  if ( PreVal.IsNull() )
   {
    //    ,   
    return ;
   }
  if ( PreVal.IsEmpty() )
   {
    //      
    SetObjectProp ( Obj , Info -> Name , NULL ) ;
    return ;
   }

  AnsiString CompName = PreVal ;
  if ( CompName.IsEmpty() ) return ;
  TComponent* Comp = Owner -> FindComponent (CompName) ;
  SetObjectProp ( Obj , Info -> Name , Comp ) ;
}
//--------------------------------------------------------------------------
 void __fastcall TXMLPropsStorage::WriteTPictureProp ( AnsiString OwnerComponentName , TComponent* Obj , TPicture* Prop , TPropInfo* Info )
 {
   if (!Prop) return ;

   AnsiString EncodeData ;

   FDataConvertor -> ToolsStream -> Clear() ;

    if ( dynamic_cast<Graphics::TBitmap*>(Prop -> Graphic) )
     {
       FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "DataType" , "Bitmap" , true );
       Prop -> Bitmap -> SaveToStream ( FDataConvertor -> ToolsStream ) ;
       FDataConvertor -> Encode ( EncodeData ) ;
       FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "DataVal" , EncodeData , true );
       return ;
     }

    if ( dynamic_cast<TIcon*>(Prop -> Graphic) )
     {
       FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "DataType" , "Icon" , true );
       Prop -> Icon -> SaveToStream ( FDataConvertor -> ToolsStream ) ;
       FDataConvertor -> Encode ( EncodeData ) ;
       FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "DataVal" , EncodeData , true );
       return ;
     }


    if ( dynamic_cast<TMetafile*>(Prop -> Graphic) )
     {
       FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "DataType" , "Metafile" , true );
       Prop -> Metafile -> SaveToStream ( FDataConvertor -> ToolsStream ) ;
       FDataConvertor -> Encode ( EncodeData ) ;
       FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "DataVal" , EncodeData , true );
     }

   return ;
 }
//--------------------------------------------------------------------------
 void __fastcall TXMLPropsStorage::ReadTPictureProp ( AnsiString OwnerComponentName , TComponent* Obj , TPicture* Prop , TPropInfo* Info )
 {
   if ( !Prop ) return ;

   OleVariant PreVal = FXMLStorage -> GetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "DataType" , VNull );
   if ( PreVal.IsNull() )
        {
         //    ,   
         return ;
        }
   AnsiString DataType = PreVal ;
   PreVal = FXMLStorage -> GetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name , "DataVal" , VNull );
   if ( PreVal.IsNull() )
        {
         //    ,   
         return ;
        }
   AnsiString EncodeData = PreVal ;

   if ( DataType == "Bitmap" )
    {
     FDataConvertor -> ToolsStream -> Clear() ;
     FDataConvertor -> Decode ( EncodeData ) ;
     Prop -> Bitmap -> LoadFromStream ( FDataConvertor -> ToolsStream ) ;
     return ;
    }
   if ( DataType == "Icon" )
    {
     FDataConvertor -> ToolsStream -> Clear() ;
     FDataConvertor -> Decode ( EncodeData ) ;
     Prop -> Icon -> LoadFromStream ( FDataConvertor -> ToolsStream ) ;
     return ;
    }
   if ( DataType == "Metafile" )
    {
     FDataConvertor -> ToolsStream -> Clear() ;
     FDataConvertor -> Decode ( EncodeData ) ;
     Prop -> Metafile -> LoadFromStream ( FDataConvertor -> ToolsStream ) ;
    }
 }
//---------------------------------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::WriteTFontProp (  AnsiString OwnerComponentName , TComponent* Obj , TFont* Prop , TPropInfo* Info )
{
   if (!Prop) return ;

   AnsiString TontTag = OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name + "\\";

   FXMLStorage -> SetTagAttribute( TontTag + "Style", "Val" , GetSetProp(Prop, "Style" ) , true );
   FXMLStorage -> SetTagAttribute( TontTag + "Size" , "Val" , Prop -> Size , true );
   FXMLStorage -> SetTagAttribute( TontTag + "Color" , "Val" , ColorToString ( Prop -> Color ) , true );
   FXMLStorage -> SetTagAttribute( TontTag + "PixelsPerInch" , "Val" , Prop -> PixelsPerInch , true );
   FXMLStorage -> SetTagAttribute( TontTag + "Pitch", "Val" , GetEnumProp(Prop , "Pitch") , true );
   FXMLStorage -> SetTagAttribute( TontTag + "Name" , "Val" , Prop -> Name , true );
   FXMLStorage -> SetTagAttribute( TontTag + "Height" , "Val" , Prop -> Height , true );
   AnsiString Charset ;
   CharsetToIdent(Prop -> Charset, Charset ) ;
   FXMLStorage -> SetTagAttribute( TontTag + "Charset" , "Val" , Charset , true );

}
//---------------------------------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::ReadTFontProp ( AnsiString OwnerComponentName , TComponent* Obj , TFont* Prop , TPropInfo* Info )
{
   if ( !Prop ) return ;

   AnsiString FontTag = OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name + "\\" ;


   OleVariant PreVal = FXMLStorage -> GetTagAttribute( FontTag + "Color", "Val" , VNull ) ;
   if ( !PreVal.IsNull() )  Prop -> Color = StringToColor (PreVal) ;

   PreVal = FXMLStorage -> GetTagAttribute( FontTag + "Height" , "Val" , VNull ) ;
   if ( !PreVal.IsNull() )  Prop -> Height = PreVal ;


   PreVal = FXMLStorage -> GetTagAttribute( FontTag + "Name" , "Val" , VNull ) ;
   if ( !PreVal.IsNull() ) Prop -> Name = PreVal  ;

   PreVal = FXMLStorage -> GetTagAttribute( FontTag + "Pitch" , "Val" , VNull ) ;
   if ( !PreVal.IsNull() )   SetEnumProp(Prop, "Pitch" , PreVal ) ;

   PreVal = FXMLStorage -> GetTagAttribute( FontTag + "PixelsPerInch" , "Val" , VNull ) ;
   if ( !PreVal.IsNull() )  Prop -> PixelsPerInch = PreVal  ;

   PreVal = FXMLStorage -> GetTagAttribute( FontTag + "Size" , "Val" ,  VNull ) ;
   if ( !PreVal.IsNull() )  Prop -> Size = PreVal  ;

   PreVal = FXMLStorage -> GetTagAttribute( FontTag + "Style" , "Val" , VNull ) ;
   if ( !PreVal.IsNull() )  SetSetProp(Prop, "Style" , PreVal ) ;

   PreVal = FXMLStorage -> GetTagAttribute( FontTag + "Charset" , "Val" , VNull );
   if ( !PreVal.IsNull() )
        {
          int CharSet ;
          IdentToCharset ( PreVal , CharSet) ;
          Prop -> Charset = CharSet ;
        }
}
//------------------------------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::WriteTTreeNodesProp ( AnsiString OwnerComponentName , TComponent* Obj, TTreeNodes* Prop , TPropInfo* Info )
{
  if (!Prop) return ;

  AnsiString ParentNodeTag = OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name + "\\"  ;
  ParentNodeTag = ParentNodeTag  ;

  int NullLevelNodeCount = 0 ;
  for ( int Index = 0 ; Index < Prop -> Count ; Index ++ )
   {
     if (!Prop -> Item[Index] -> Parent)
       {
        WriteTTreeNode ( ParentNodeTag + "Node" + AnsiString(NullLevelNodeCount) + "\\" , Prop -> Item[Index] ) ;
        NullLevelNodeCount ++ ;
       }
   }

  FXMLStorage -> SetTagAttribute( ParentNodeTag , "RootCount" , NullLevelNodeCount , true );
}
void __fastcall TXMLPropsStorage::WriteTTreeNode ( AnsiString StoredNodeTag , TTreeNode* StoredNode  )
{
  try {
       if ( StoredNode -> Count )
         {
          FXMLStorage -> SetTagAttribute( StoredNodeTag + "Count", "Val" , StoredNode -> Count , true );
         }
        FXMLStorage -> SetTagAttribute( StoredNodeTag + "Cut" , "Val"  , StoredNode -> Cut  , true );

        if ( StoredNode -> Data )
          {

           FXMLStorage -> SetTagAttribute( StoredNodeTag + "Data", "Val" , "0x" + IntToHex((int)StoredNode -> Data , 8 ) , true );
          }


        FXMLStorage -> SetTagAttribute( StoredNodeTag + "Expanded", "Val" , StoredNode -> Expanded , true );

        FXMLStorage -> SetTagAttribute( StoredNodeTag + "Focused", "Val"  , StoredNode -> Focused , true );

        FXMLStorage -> SetTagAttribute( StoredNodeTag + "HasChildren", "Val" , StoredNode -> HasChildren , true );

        FXMLStorage -> SetTagAttribute( StoredNodeTag + "ImageIndex", "Val"  , StoredNode -> ImageIndex , true );

        FXMLStorage -> SetTagAttribute( StoredNodeTag + "OverlayIndex" , "Val" , StoredNode -> OverlayIndex , true );

        FXMLStorage -> SetTagAttribute( StoredNodeTag + "Selected" , "Val" , StoredNode -> Selected , true );

        FXMLStorage -> SetTagAttribute( StoredNodeTag + "SelectedIndex", "Val" , StoredNode -> SelectedIndex , true );

        FXMLStorage -> SetTagAttribute( StoredNodeTag + "StateIndex" , "Val" , StoredNode -> StateIndex , true );

        FXMLStorage -> SetTagAttribute( StoredNodeTag + "Text", "Val"  , StoredNode -> Text , true );

        //    
        for ( int Index = 0 ; Index < StoredNode -> Count ; Index ++ )
            {
              WriteTTreeNode ( StoredNodeTag + "Items\\Node" + AnsiString(Index) + "\\" , StoredNode -> Item[Index] )  ;
            }
      } catch (...) {}
}

void __fastcall TXMLPropsStorage::ReadTTreeNodesProp ( AnsiString OwnerComponentName , TComponent* Obj , TTreeNodes* Prop , TPropInfo* Info )
{
  if ( !Prop ) return ;
  try
   {
     Prop -> BeginUpdate() ;
     Prop -> Clear() ;
     AnsiString ParentNodeTag = OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name + "\\" ;
     int NullLevelNodeCount = FXMLStorage -> GetTagAttribute( ParentNodeTag , "RootCount" , (int)0 ) ;
     for ( int Index = 0 ; Index < NullLevelNodeCount ; Index ++ )
      {
       ReadTTreeNode ( ParentNodeTag + "Node" + AnsiString(Index) + "\\" , NULL , Prop ) ;
      }
     Prop -> EndUpdate() ;
   } catch (...) {}
}

void __fastcall TXMLPropsStorage::ReadTTreeNode ( AnsiString RestoredParentNodeTag , TTreeNode* RestoredParentNode , TTreeNodes* TreeNodes )
{
  //     ParentNode 
  TTreeNode* Node = TreeNodes -> AddChildObject( RestoredParentNode , "" , NULL ) ;

  //    
  int Count = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "Count" , "Val" , (int)0 ) ;
  for ( int Index = 0 ; Index <  Count ; Index ++ )
   {
     ReadTTreeNode ( RestoredParentNodeTag + "Items\\Node" + AnsiString(Index) + "\\" , Node , TreeNodes ) ;
   }

  //  
  OleVariant PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "Text", "Val" , VNull ) ;
  if ( !PreVal.IsNull() ) Node -> Text = PreVal ;

  PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "Data", "Val" , VNull) ;
  if ( !PreVal.IsNull() ) Node -> Data = (void*)(int)PreVal ;

  PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "Cut", "Val" , VNull);
  if ( !PreVal.IsNull() )  Node -> Cut = PreVal  ;

  PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "HasChildren" , "Val" , VNull);
  if ( !PreVal.IsNull() )  Node -> HasChildren = PreVal  ;

  PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "ImageIndex", "Val" , VNull);
  if ( !PreVal.IsNull() )  Node -> ImageIndex = PreVal  ;

  PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "StateIndex", "Val" , VNull);
  if ( !PreVal.IsNull() )  Node -> StateIndex = PreVal  ;

  PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "SelectedIndex" , "Val" , VNull);
  if ( !PreVal.IsNull() )  Node -> SelectedIndex = PreVal  ;

  PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "OverlayIndex" , "Val" , NULL);
  if ( !PreVal.IsNull() )  Node -> OverlayIndex = PreVal  ;

  PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "Selected" , "Val" , NULL);
  if ( !PreVal.IsNull() ) Node -> Selected = PreVal  ;

  PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "Focused", "Val" , NULL);
  if ( !PreVal.IsNull() ) Node -> Focused = PreVal ;

  PreVal = FXMLStorage -> GetTagAttribute( RestoredParentNodeTag + "Expanded" , "Val" , NULL);
  if ( !PreVal.IsNull() )  Node -> Expanded =  PreVal  ;

}
//------------------------------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::WriteTMenuItemProp ( AnsiString OwnerComponentName , TComponent* Obj , TMenuItem* Prop , TPropInfo* Info )
{
  if (!Prop) return ;
  try
   {
     AnsiString RootItemTag = OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name + "\\"  ;
     WriteTMenuItem ( RootItemTag , Prop , 0 ) ;
   } catch (...) {}
}

void __fastcall TXMLPropsStorage::WriteTMenuItem ( AnsiString ParentItemTag , TMenuItem* Item , int ItemIndex )
{
 //     
 AnsiString ItemTag = ParentItemTag + "Item" + AnsiString(ItemIndex) + "\\" ;

 FXMLStorage -> SetTagAttribute( ItemTag + "Count", "Val" , Item -> Count , true );

 TPropInfo* Info = GetPropInfo ( Item , "Caption" ) ;
 FXMLStorage -> SetTagAttribute( ItemTag + "Caption" , "Val" , Item -> Caption , true );

 Info = GetPropInfo ( Item , "ShortCut" ) ;
 FXMLStorage -> SetTagAttribute( ItemTag + "ShortCut", "Val" , ShortCutToText(Item -> ShortCut) , true );

 Info = GetPropInfo ( Item , "Checked" ) ;
 FXMLStorage -> SetTagAttribute( ItemTag + "Checked" , "Val"  , Item -> Checked , true );

 Info = GetPropInfo ( Item , "Enabled" ) ;
 FXMLStorage -> SetTagAttribute( ItemTag + "Enabled",  "Val" , Item -> Enabled , true );

 Info = GetPropInfo ( Item , "HelpContext" ) ;
 FXMLStorage -> SetTagAttribute( ItemTag + "HelpContext" , "Val" , Item -> HelpContext , true );

 Info = GetPropInfo ( Item , "Name" ) ;
 FXMLStorage -> SetTagAttribute( ItemTag + "Name" , "Val" , Item -> Name , true );

 Info = GetPropInfo ( Item , "OnClick" ) ;
 WriteTMethod ( ItemTag , Item , Info , msmMenuItem ) ;
 Info = GetPropInfo ( Item , "OnAdvancedDrawItem" ) ;
 WriteTMethod ( ItemTag , Item , Info , msmMenuItem ) ;
 Info = GetPropInfo ( Item , "OnDrawItem" ) ;
 WriteTMethod ( ItemTag , Item , Info , msmMenuItem ) ;
 Info = GetPropInfo ( Item , "OnMeasureItem" ) ;
 WriteTMethod ( ItemTag , Item , Info , msmMenuItem ) ;

 for ( int Index = 0 ; Index < Item -> Count ; Index ++ )
   {
    TMenuItem* ChildItem = Item -> Items[Index] ;
    WriteTMenuItem ( ItemTag + "Items\\" , ChildItem , Index ) ;
   }
}
//------------------------------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::ReadTMenuItemProp ( AnsiString OwnerComponentName , TComponent* Obj , TMenuItem* Prop , TPropInfo* Info )
{
  if ( !Prop ) return ;
  Prop -> Clear() ;
  AnsiString RootItemTag = OwnerComponentName  +  Obj -> Name + "\\" +  Info -> Name + "\\"  ;
  ReadTMenuItem ( RootItemTag , Prop , 0 ) ;
}

void __fastcall TXMLPropsStorage::ReadTMenuItem ( AnsiString ParentItemTag , TMenuItem* Item , int ItemIndex )
{
 //     
 AnsiString ItemTag = ParentItemTag + "Item" + AnsiString(ItemIndex) + "\\" ;

 Item -> Caption = FXMLStorage -> GetTagAttribute( ItemTag + "Caption" , "Val" , "") ;
 Item -> ShortCut    = TextToShortCut ( FXMLStorage -> GetTagAttribute( ItemTag + "ShortCut" , "Val" , "") ) ;
 Item -> Checked     = FXMLStorage -> GetTagAttribute( ItemTag + "Checked", "Val" , false ) ;
 Item -> Enabled     = FXMLStorage -> GetTagAttribute( ItemTag + "Enabled" , "Val" , true ) ;
 Item -> HelpContext = FXMLStorage -> GetTagAttribute( ItemTag + "HelpContext" , "Val" , (int)0 ) ;
 Item -> Name        = FXMLStorage -> GetTagAttribute( ItemTag + "Name", "Val"  , "" ) ;


 TPropInfo* Info = GetPropInfo ( Item , "OnClick" ) ;
 ReadTMethod ( ItemTag , Item , Info , msmMenuItem ) ;
 Info = GetPropInfo ( Item , "OnAdvancedDrawItem" ) ;
 ReadTMethod ( ItemTag , Item , Info , msmMenuItem ) ;
 Info = GetPropInfo ( Item , "OnDrawItem" ) ;
 ReadTMethod ( ItemTag , Item , Info , msmMenuItem ) ;
 Info = GetPropInfo ( Item , "OnMeasureItem" ) ;
 ReadTMethod ( ItemTag , Item , Info , msmMenuItem ) ;

 int ItemCount = FXMLStorage -> GetTagAttribute( ItemTag + "Count" , "Val" , (int)0 ) ;

 for ( int Index = 0 ; Index < ItemCount ; Index ++ )
   {
    TMenuItem *ChildItem = NewItem( NULL  , NULL , false , true , NULL , 0 , "NewMenuItem" ) ;
    ReadTMenuItem ( ItemTag + "Items\\" , ChildItem , Index ) ;
    Item -> Add ( ChildItem ) ;
   }
}
//------------------------------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::WriteStringGridUnpublishedProp ( AnsiString OwnerComponentName , TStringGrid* Obj , AnsiString PropName )
{
  if (  PropName == "Cells")
   {
     //  TStringsGrid->Cells
     FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\Cells" , "RowCount" , Obj->RowCount , true );
     FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\Cells" , "ColCount" , Obj->ColCount , true );
     for ( int Row = 0 ; Row < Obj->RowCount ; Row++ )
      {
        for ( int Col = 0 ; Col < Obj->ColCount ; Col++ )
         {
           FXMLStorage -> SetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\Cells\\Row"+ AnsiString(Row) + "\\Col"+ AnsiString(Col) , "Val" , Obj->Cells[Col][Row] , true );
         }
      }
   }
}
//------------------------------------------------------------------------------------------------
void __fastcall TXMLPropsStorage::ReadStringGridUnpublishedProp ( AnsiString OwnerComponentName , TStringGrid* Obj , AnsiString PropName )
{
  if (  PropName == "Cells")
   {
     //  TStringsGrid->Cells
     int RowCount = FXMLStorage -> GetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\Cells" , "RowCount" , 2 );
     int ColCount = FXMLStorage -> GetTagAttribute( OwnerComponentName  +  Obj -> Name + "\\Cells" , "ColCount" , 2 );
     Obj->ColCount = ColCount ;
     Obj->RowCount = RowCount ;
     for ( int Row = 0 ; Row < Obj->RowCount ; Row++ )
      {
        for ( int Col = 0 ; Col < Obj->ColCount ; Col++ )
         {
            Obj->Cells[Col][Row] = FXMLStorage -> GetTagAttribute( OwnerComponentName  +  Obj -> Name + +"\\Cells\\Row"+ AnsiString(Row) + "\\Col"+ AnsiString(Col) , "Val" , "" );
         }
      }
   }
}

